function CSGBooleanFunction(
    typeDropdown,
    typeInput,
    objInput1,
    objInput2,
    resultObjectNameInput,
    whenDone_Statement_Input
) {
    function mainFunction() {
        function checkType() {
            typeInput && "" != typeInput
                ? ((booleanType = typeInput), CSG_Function())
                : ((booleanType = typeDropdown), CSG_Function());
        }
        function checkJSLoaded() {
            "undefined" == typeof window.CSG_js_loaded
                ? jsFileLoaderTop(wait)
                : "loaded" == window.CSG_js_loaded && CSG_Function();
        }
        function wait() {
            setTimeout(CSG_Function(), 10);
        }
        function CSG_Function() {
            "loaded" == window.CSG_js_loaded;
            let meshA = window.appGlobal.scene.getObjectByName(objInput1),
                meshB = window.appGlobal.scene.getObjectByName(objInput2);
            meshA.updateMatrix(), meshB.updateMatrix();
            let bspA = CSG.fromMesh(meshA),
                bspB = CSG.fromMesh(meshB),
                bspResult_preEval = `bspA.${booleanType}(bspB);`,
                bspResult = eval(bspResult_preEval),
                meshResult = CSG.toMesh(
                    bspResult,
                    meshA.matrix,
                    meshA.material
                );
            (meshResult.name = resultObjectNameInput),
                window.appGlobal.scene.add(meshResult),
                whenDone_Statement_Input();
        }
        let booleanType;
        class CSG {
            constructor() {
                this.polygons = [];
            }
            clone() {
                let b = new CSG();
                return (
                    (b.polygons = this.polygons.map(function (b) {
                        return b.clone();
                    })),
                    b
                );
            }
            toPolygons() {
                return this.polygons;
            }
            union(b) {
                let c = new Node(this.clone().polygons),
                    d = new Node(b.clone().polygons);
                return (
                    c.clipTo(d),
                    d.clipTo(c),
                    d.invert(),
                    d.clipTo(c),
                    d.invert(),
                    c.build(d.allPolygons()),
                    CSG.fromPolygons(c.allPolygons())
                );
            }
            subtract(b) {
                let c = new Node(this.clone().polygons),
                    d = new Node(b.clone().polygons);
                return (
                    c.invert(),
                    c.clipTo(d),
                    d.clipTo(c),
                    d.invert(),
                    d.clipTo(c),
                    d.invert(),
                    c.build(d.allPolygons()),
                    c.invert(),
                    CSG.fromPolygons(c.allPolygons())
                );
            }
            intersect(b) {
                let c = new Node(this.clone().polygons),
                    d = new Node(b.clone().polygons);
                return (
                    c.invert(),
                    d.clipTo(c),
                    d.invert(),
                    c.clipTo(d),
                    d.clipTo(c),
                    c.build(d.allPolygons()),
                    c.invert(),
                    CSG.fromPolygons(c.allPolygons())
                );
            }
            inverse() {
                let b = this.clone();
                return b.polygons.forEach((b) => b.flip()), b;
            }
        }
        CSG.fromPolygons = function (c) {
            let a = new CSG();
            return (a.polygons = c), a;
        };
        class Vector {
            constructor(d = 0, a = 0, b = 0) {
                (this.x = d), (this.y = a), (this.z = b);
            }
            copy(b) {
                return (this.x = b.x), (this.y = b.y), (this.z = b.z), this;
            }
            clone() {
                return new Vector(this.x, this.y, this.z);
            }
            negate() {
                return (this.x *= -1), (this.y *= -1), (this.z *= -1), this;
            }
            add(a) {
                return (this.x += a.x), (this.y += a.y), (this.z += a.z), this;
            }
            sub(a) {
                return (this.x -= a.x), (this.y -= a.y), (this.z -= a.z), this;
            }
            times(a) {
                return (this.x *= a), (this.y *= a), (this.z *= a), this;
            }
            dividedBy(a) {
                return (this.x /= a), (this.y /= a), (this.z /= a), this;
            }
            lerp(c, b) {
                return this.add(tv0.copy(c).sub(this).times(b));
            }
            unit() {
                return this.dividedBy(this.length());
            }
            length() {
                return Math.sqrt(this.x ** 2 + this.y ** 2 + this.z ** 2);
            }
            normalize() {
                return this.unit();
            }
            cross(i) {
                let c = this;
                const b = c.x,
                    a = c.y,
                    d = c.z,
                    e = i.x,
                    f = i.y,
                    g = i.z;
                return (
                    (this.x = a * g - d * f),
                    (this.y = d * e - b * g),
                    (this.z = b * f - a * e),
                    this
                );
            }
            dot(b) {
                return this.x * b.x + this.y * b.y + this.z * b.z;
            }
        }
        let tv0 = new Vector(),
            tv1 = new Vector();
        class Vertex {
            constructor(e, a, b, c) {
                (this.pos = new Vector().copy(e)),
                    (this.normal = new Vector().copy(a)),
                    (this.uv = new Vector().copy(b)),
                    (this.uv.z = 0),
                    c && (this.color = new Vector().copy(c));
            }
            clone() {
                return new Vertex(this.pos, this.normal, this.uv, this.color);
            }
            flip() {
                this.normal.negate();
            }
            interpolate(c, a) {
                return new Vertex(
                    this.pos.clone().lerp(c.pos, a),
                    this.normal.clone().lerp(c.normal, a),
                    this.uv.clone().lerp(c.uv, a),
                    this.color && c.color && this.color.clone().lerp(c.color, a)
                );
            }
        }
        class Plane {
            constructor(c, a) {
                (this.normal = c), (this.w = a);
            }
            clone() {
                return new Plane(this.normal.clone(), this.w);
            }
            flip() {
                this.normal.negate(), (this.w = -this.w);
            }
            splitPolygon(i, a, b, c, d) {
                const e = 0,
                    j = 1,
                    k = 2,
                    l = 3;
                let g = 0,
                    m = [];
                for (let f = 0; f < i.vertices.length; f++) {
                    let a = this.normal.dot(i.vertices[f].pos) - this.w,
                        b = a < -Plane.EPSILON ? k : a > Plane.EPSILON ? j : e;
                    (g |= b), m.push(b);
                }
                switch (g) {
                    case e:
                        (0 < this.normal.dot(i.plane.normal) ? a : b).push(i);
                        break;
                    case j:
                        c.push(i);
                        break;
                    case k:
                        d.push(i);
                        break;
                    case l:
                        let n = [],
                            o = [];
                        for (let a = 0; a < i.vertices.length; a++) {
                            let b = (a + 1) % i.vertices.length,
                                c = m[a],
                                d = m[b],
                                e = i.vertices[a],
                                f = i.vertices[b];
                            if (
                                (c != k && n.push(e),
                                c != j && o.push(c == k ? e : e.clone()),
                                (c | d) == l)
                            ) {
                                let c =
                                        (this.w - this.normal.dot(e.pos)) /
                                        this.normal.dot(
                                            tv0.copy(f.pos).sub(e.pos)
                                        ),
                                    a = e.interpolate(f, c);
                                n.push(a), o.push(a.clone());
                            }
                        }
                        3 <= n.length && c.push(new Polygon(n, i.shared)),
                            3 <= o.length && d.push(new Polygon(o, i.shared));
                }
            }
        }
        (Plane.EPSILON = 1e-5),
            (Plane.fromPoints = function (e, d, a) {
                let b = tv0
                    .copy(d)
                    .sub(e)
                    .cross(tv1.copy(a).sub(e))
                    .normalize();
                return new Plane(b.clone(), b.dot(e));
            });
        class Polygon {
            constructor(c, a) {
                (this.vertices = c),
                    (this.shared = a),
                    (this.plane = Plane.fromPoints(
                        c[0].pos,
                        c[1].pos,
                        c[2].pos
                    ));
            }
            clone() {
                return new Polygon(
                    this.vertices.map((b) => b.clone()),
                    this.shared
                );
            }
            flip() {
                this.vertices.reverse().map((b) => b.flip()), this.plane.flip();
            }
        }
        class Node {
            constructor(b) {
                (this.plane = null),
                    (this.front = null),
                    (this.back = null),
                    (this.polygons = []),
                    b && this.build(b);
            }
            clone() {
                let b = new Node();
                return (
                    (b.plane = this.plane && this.plane.clone()),
                    (b.front = this.front && this.front.clone()),
                    (b.back = this.back && this.back.clone()),
                    (b.polygons = this.polygons.map((b) => b.clone())),
                    b
                );
            }
            invert() {
                for (let b = 0; b < this.polygons.length; b++)
                    this.polygons[b].flip();
                this.plane && this.plane.flip(),
                    this.front && this.front.invert(),
                    this.back && this.back.invert();
                let b = this.front;
                (this.front = this.back), (this.back = b);
            }
            clipPolygons(e) {
                if (!this.plane) return e.slice();
                let a = [],
                    f = [];
                for (let b = 0; b < e.length; b++)
                    this.plane.splitPolygon(e[b], a, f, a, f);
                return (
                    this.front && (a = this.front.clipPolygons(a)),
                    (f = this.back ? this.back.clipPolygons(f) : []),
                    a.concat(f)
                );
            }
            clipTo(b) {
                (this.polygons = b.clipPolygons(this.polygons)),
                    this.front && this.front.clipTo(b),
                    this.back && this.back.clipTo(b);
            }
            allPolygons() {
                let b = this.polygons.slice();
                return (
                    this.front && (b = b.concat(this.front.allPolygons())),
                    this.back && (b = b.concat(this.back.allPolygons())),
                    b
                );
            }
            build(e) {
                if (e.length) {
                    this.plane || (this.plane = e[0].plane.clone());
                    let a = [],
                        b = [];
                    for (let c = 0; c < e.length; c++)
                        this.plane.splitPolygon(
                            e[c],
                            this.polygons,
                            this.polygons,
                            a,
                            b
                        );
                    a.length &&
                        (!this.front && (this.front = new Node()),
                        this.front.build(a)),
                        b.length &&
                            (!this.back && (this.back = new Node()),
                            this.back.build(b));
                }
            }
        }
        (CSG.fromJSON = function (b) {
            return CSG.fromPolygons(
                b.polygons.map(
                    (b) =>
                        new Polygon(
                            b.vertices.map(
                                (b) => new Vertex(b.pos, b.normal, b.uv)
                            ),
                            b.shared
                        )
                )
            );
        }),
            "use strict",
            (CSG.fromGeometry = function (j, l) {
                let b = [];
                if (j.isGeometry) {
                    let a = j.faces,
                        c = j.vertices,
                        d = ["a", "b", "c"];
                    for (let e = 0; e < a.length; e++) {
                        let g = a[e],
                            h = [];
                        for (let a = 0; 3 > a; a++)
                            h.push(
                                new Vertex(
                                    c[g[d[a]]],
                                    g.vertexNormals[a],
                                    j.faceVertexUvs[0][e][a]
                                )
                            );
                        b.push(new Polygon(h, l));
                    }
                } else if (j.isBufferGeometry) {
                    let r,
                        d = j.attributes.position,
                        e = j.attributes.normal,
                        f = j.attributes.uv,
                        g = j.attributes.color;
                    if (j.index) r = j.index.array;
                    else {
                        r = Array(0 | (d.array.length / d.itemSize));
                        for (let b = 0; b < r.length; b++) r[b] = b;
                    }
                    let a = 0 | (r.length / 3);
                    b = Array(a);
                    for (
                        let h, a = 0, c = 0, i = r.length;
                        a < i;
                        a += 3, c++
                    ) {
                        h = [, , ,];
                        for (let k = 0; 3 > k; k++) {
                            let b = r[a + k],
                                c = 3 * b,
                                i = 2 * b,
                                j = d.array[c],
                                l = d.array[c + 1],
                                m = d.array[c + 2],
                                n = e.array[c],
                                o = e.array[c + 1],
                                p = e.array[c + 2];
                            h[k] = new Vertex(
                                {
                                    x: j,
                                    y: l,
                                    z: m,
                                },
                                {
                                    x: n,
                                    y: o,
                                    z: p,
                                },
                                f && {
                                    x: f.array[i],
                                    y: f.array[i + 1],
                                    z: 0,
                                },
                                g && {
                                    x: g.array[i],
                                    y: g.array[i + 1],
                                    z: g.array[i + 2],
                                }
                            );
                        }
                        b[c] = new Polygon(h, l);
                    }
                } else console.error("Unsupported CSG input type:" + j.type);
                return CSG.fromPolygons(b);
            });
        let ttvv0 = new THREE.Vector3(),
            tmpm3 = new THREE.Matrix3();
        CSG.fromMesh = function (e, a) {
            let b = CSG.fromGeometry(e.geometry, a);
            tmpm3.getNormalMatrix(e.matrix);
            for (let f, c = 0; c < b.polygons.length; c++) {
                f = b.polygons[c];
                for (let a, b = 0; b < f.vertices.length; b++)
                    (a = f.vertices[b]),
                        a.pos.copy(ttvv0.copy(a.pos).applyMatrix4(e.matrix)),
                        a.normal.copy(ttvv0.copy(a.normal).applyMatrix3(tmpm3));
            }
            return b;
        };
        let nbuf3 = (b) => ({
                top: 0,
                array: new Float32Array(b),
                write: function (b) {
                    (this.array[this.top++] = b.x),
                        (this.array[this.top++] = b.y),
                        (this.array[this.top++] = b.z);
                },
            }),
            nbuf2 = (b) => ({
                top: 0,
                array: new Float32Array(b),
                write: function (b) {
                    (this.array[this.top++] = b.x),
                        (this.array[this.top++] = b.y);
                },
            });
        (CSG.toGeometry = function (e, a = !0) {
            let j,
                k = e.polygons;
            if (!a) {
                j = new Geometry();
                let c = j.vertices,
                    l = j.faceVertexUvs[0];
                for (let a = 0; a < k.length; a++) {
                    let b = k[a],
                        f = b.vertices,
                        g = c.length,
                        d = f.length;
                    for (let a = 0; a < d; a++)
                        c.push(new THREE.Vector3().copy(f[a].pos));
                    for (let c = 3; c <= d; c++) {
                        let a = new THREE.Face3(),
                            d = [];
                        l.push(d);
                        let e = a.vertexNormals;
                        (a.a = g),
                            (a.b = g + c - 2),
                            (a.c = g + c - 1),
                            e.push(new THREE.Vector3().copy(f[0].normal)),
                            e.push(new THREE.Vector3().copy(f[c - 2].normal)),
                            e.push(new THREE.Vector3().copy(f[c - 1].normal)),
                            d.push(new THREE.Vector3().copy(f[0].uv)),
                            d.push(new THREE.Vector3().copy(f[c - 2].uv)),
                            d.push(new THREE.Vector3().copy(f[c - 1].uv)),
                            (a.normal = new THREE.Vector3().copy(
                                b.plane.normal
                            )),
                            j.faces.push(a);
                    }
                }
                (j = new THREE.BufferGeometry().fromGeometry(j)),
                    (j.verticesNeedUpdate =
                        j.elementsNeedUpdate =
                        j.normalsNeedUpdate =
                            !0);
            } else {
                let l = 0;
                k.forEach((a) => (l += a.vertices.length - 2)),
                    (j = new THREE.BufferGeometry());
                let m,
                    b = nbuf3(3 * (3 * l)),
                    e = nbuf3(3 * (3 * l)),
                    f = nbuf2(3 * (2 * l)),
                    g = [];
                if (
                    (k.forEach((h) => {
                        let c = h.vertices,
                            d = c.length;
                        void 0 === h.shared ||
                            g[h.shared] ||
                            (g[h.shared] = []),
                            d &&
                                void 0 !== c[0].color &&
                                !m &&
                                (m = nbuf3(3 * (3 * l)));
                        for (let i = 3; i <= d; i++)
                            void 0 !== h.shared &&
                                g[h.shared].push(
                                    b.top / 3,
                                    b.top / 3 + 1,
                                    b.top / 3 + 2
                                ),
                                b.write(c[0].pos),
                                b.write(c[i - 2].pos),
                                b.write(c[i - 1].pos),
                                e.write(c[0].normal),
                                e.write(c[i - 2].normal),
                                e.write(c[i - 1].normal),
                                (f && f.write(c[0].uv)) ||
                                    f.write(c[i - 2].uv) ||
                                    f.write(c[i - 1].uv),
                                m &&
                                    (m.write(c[0].color) ||
                                        m.write(c[i - 2].color) ||
                                        m.write(c[i - 1].color));
                    }),
                    j.setAttribute(
                        "position",
                        new THREE.BufferAttribute(b.array, 3)
                    ),
                    j.setAttribute(
                        "normal",
                        new THREE.BufferAttribute(e.array, 3)
                    ),
                    f &&
                        j.setAttribute(
                            "uv",
                            new THREE.BufferAttribute(f.array, 2)
                        ),
                    m &&
                        j.setAttribute(
                            "color",
                            new THREE.BufferAttribute(m.array, 3)
                        ),
                    g.length)
                ) {
                    let c = [],
                        a = 0;
                    for (let b = 0; b < g.length; b++)
                        j.addGroup(a, g[b].length, b),
                            (a += g[b].length),
                            (c = c.concat(g[b]));
                    j.setIndex(c);
                }
            }
            return j;
        }),
            (CSG.toMesh = function (g, a, b) {
                let c = CSG.toGeometry(g),
                    d = new THREE.Matrix4().copy(a).invert();
                c.applyMatrix4(d),
                    c.computeBoundingSphere(),
                    c.computeBoundingBox();
                let e = new THREE.Mesh(c, b);
                return (
                    e.matrix.copy(a),
                    e.matrix.decompose(e.position, e.quaternion, e.scale),
                    e.rotation.setFromQuaternion(e.quaternion),
                    e.updateMatrixWorld(),
                    (e.castShadow = e.receiveShadow = !0),
                    e
                );
            }),
            checkType();
    }
    const puzzleName = "CSG Boolean";
    objInput1
        ? mainFunction()
        : console.log(
              "[ GLIFTEK ]: The",
              "CSG Boolean",
              "plugin puzzle is missing an input!"
          );
}
