//url test

"use strict";

/* __V3D_TEMPLATE__ - template-based file; delete this line to prevent this file from being updated */
/**
 * Code starting here.
 * Initialization
 */

var appGlobal;
const queryString = window.location.search;
const urlParams = new URLSearchParams(queryString);
var initialAngleValue = 0;
var appGlobal;
window.appGlobal = appGlobal;

let widths = [
    1059, 1241, 1423, 1605, 1787, 1969, 2151, 2333, 2515, 2697, 2879, 3061,
    3243, 3425, 3607, 3789, 3971, 4153, 4335, 4517, 4699, 4881, 5063, 5245,
    5427, 5609, 5791, 5973, 6155, 6337, 6519, 6701, 6883, 7065, 7247, 7429,
    7611, 7793, 7975, 8157, 8339, 8521, 8703, 8885, 9067, 9249, 9431, 9613,
    9795, 9977, 10159,
];

let lengths = [
    1059, 1241, 1423, 1605, 1787, 1969, 2151, 2333, 2515, 2697, 2879, 3061,
    3243, 3425, 3607, 3789, 3971, 4153, 4335, 4517, 4699, 4881, 5063, 5245,
    5427, 5609, 5791, 5973, 6155, 6337, 6519, 6701, 6883, 7065, 7247, 7429,
    7611, 7793, 7975, 8157, 8339, 8521, 8703, 8885, 9067, 9249, 9431, 9613,
    9795, 9977, 10159,
];
let heights = [
    // 400, 500, 600, 700, 800, 900,
    1000, 1100, 1200, 1300, 1400, 1500, 1600, 1700, 1800, 1900, 2000, 2100,
    2200, 2300, 2400, 2500, 2600, 2700, 2800, 2900, 3000, 3100, 3200, 3300,
    3400, 3500, 3600,
];
const standardPolePositions = ["", "P1", "P2", "P3", "P4"];
const sides = ["", "P1-P2", "P1-P3", "P2-P4", "P3-P4"];
let allPossiblePolePositions = [];
let allPossibleCombinations = [];

// these valus repsets limiters for the scaling pergola
var lamela_rotation = 0;
var xScaleCounter = 4;
var yScaleCounter = 6;
var zScaleCounter = 10;
var inputWidthIndex = 0;
var inputLengthIndex = 0;
var inputHeightIndex = 0;
var zipHeight = 0.6;
var sunMoveForBitCounter = 0;

var globalInputIstallationType = "Type1";
var globalInputLenghtMesureValue = 5000;
var globalInputWidthMesureValue = 4000; // only for visual mesures, because real value is converted in closest one in the catallog
var globalInputHeightMesureValue = 2500;
var globalInputLength = 5000;
var globalLengthChanges = false;
var globalInputWidth = 4000;
var globalWidthChanges = false;
var globalInputHeight = 2500; // TO GET ERROR
var globalHeightChanges = false;
var globalInputStructureColor = "RAL_9001";
var globalStructureColorChanges = false;
var globalInputBladesColor = "RAL_9001";
var globalBladesColorChanges = false;
var globalInputPolesArray = [
    { position: "P1", height: 2500 },
    { position: "P2", height: 2500 },
    { position: "P3", height: 2500 },
    { position: "P4", height: 2500 },
];
var globalInputPolesArrayEmpty = false;
var globalPolesArrayChanges = false;
var globalInputAdditionalPolesArray = [];
var globalAdditionalPolesArrayChanges = false;
var globalInputWallMountingArray = [];
var globalWallMountingArrayChanges = false;
var globalInputGlassArray = [];
var globalWallGlassArrayChanges = false;
var globalInputZipArray = [];
var globalZipArrayChanges = false;
var globalInputSlideArray = [];
var globalSlideArrayChanges = false;
var globalInputWaterEvacuation = [
    { position: "(W) A1", key: "A1", checked: false },
    { position: "(W) B1", key: "B1", checked: false },
    { position: "(W) A2", key: "A2", checked: false },
    { position: "(W) B2", key: "B2", checked: false },
    { position: "(W) A3", key: "A3", checked: false },
    { position: "(W) B3", key: "B3", checked: false },
    { position: "(W) A4", key: "A4", checked: false },
    { position: "(W) B4", key: "B4", checked: false },
];
var globalWaterEvacuationChanges = false;
var globalInputPowerSupply = "/";
var globalPowerSupplyChanges = false;
var globalInputMotor = "/";
var globaltMotorChanges = false;
let genereatedNumberList = [];

let globalOldScaleValueP1_P2;
let globalOldScaleValueP1_P3;
let globalOldScaleValueP2_P4;
let globalOldScaleValueP3_P4;
let lightsInit = false;

window.addEventListener("load", function () {
    doSomething();
});

function doSomething() {
    var CONTAINER_ID = "v3d-container";

    (function () {
        var params = v3d.AppUtils.getPageParams();

        var PUZZLES_DIR = "/puzzles/";
        var logicURL = params.logic
            ? params.logic
            : "__LOGIC__visual_logic.js".replace("__LOGIC__", "");
        var sceneURL = params.load
            ? params.load
            : "__URL__pergola.gltf".replace("__URL__", "");
        if (!sceneURL) {
            return;
        }

        // some puzzles can benefit from cache
        v3d.Cache.enabled = true;

        if (v3d.AppUtils.isXML(logicURL)) {
            var logicURLJS = logicURL.match(/(.*)\.xml$/)[1] + ".js";
            new v3d.PuzzlesLoader().loadEditorWithLogic(
                PUZZLES_DIR,
                logicURLJS,
                function () {
                    var initOptions = v3d.PL
                        ? v3d.PL.execInitPuzzles({
                              container: CONTAINER_ID,
                          }).initOptions
                        : { useFullscreen: true };
                    var appInstance = loadScene(sceneURL, initOptions);
                    v3d.PE.viewportUseAppInstance(appInstance);
                }
            );
        } else if (v3d.AppUtils.isJS(logicURL)) {
            new v3d.PuzzlesLoader().loadLogic(logicURL, function () {
                var initOptions = v3d.PL
                    ? v3d.PL.execInitPuzzles({
                          container: CONTAINER_ID,
                      }).initOptions
                    : { useFullscreen: true };
                loadScene(sceneURL, initOptions);
            });
        } else {
            loadScene(sceneURL, { useFullscreen: true });
        }
    })();

    function loadScene(sceneURL, initOptions) {
        initOptions = initOptions || {};

        var ctxSettings = {};
        if (initOptions.useBkgTransp) ctxSettings.alpha = true;
        if (initOptions.preserveDrawBuf)
            ctxSettings.preserveDrawingBuffer = true;

        var preloader = initOptions.useCustomPreloader
            ? createCustomPreloader(
                  initOptions.preloaderProgressCb,
                  initOptions.preloaderEndCb
              )
            : new v3d.SimplePreloader({ container: CONTAINER_ID });

        if (v3d.PE) {
            puzzlesEditorPreparePreloader(preloader);
        }

        var app = new v3d.App(CONTAINER_ID, ctxSettings, preloader);
        if (initOptions.useBkgTransp) {
            app.clearBkgOnLoad = true;
            app.renderer.setClearColor(0x000000, 0);
        }

        // namespace for communicating with code generated by Puzzles
        app.ExternalInterface = {};
        prepareExternalInterface(app);

        if (initOptions.preloaderStartCb) initOptions.preloaderStartCb();
        if (initOptions.useFullscreen) {
            initFullScreen();
        } else {
            var fsButton = document.getElementById("fullscreen_button");
            if (fsButton) fsButton.style.display = "none";
        }

        sceneURL = initOptions.useCompAssets ? sceneURL + ".xz" : sceneURL;
        app.loadScene(
            sceneURL,
            function () {
                app.enableControls();
                app.run();

                if (v3d.PE) v3d.PE.updateAppInstance(app);
                if (v3d.PL) v3d.PL.init(app, initOptions);

                runCode(app);
            },
            null,
            function () {}
        );

        return app;
    }

    function createCustomPreloader(updateCb, finishCb) {
        function CustomPreloader() {
            v3d.Preloader.call(this);
        }

        CustomPreloader.prototype = Object.assign(
            Object.create(v3d.Preloader.prototype),
            {
                onUpdate: function (percentage) {
                    v3d.Preloader.prototype.onUpdate.call(this, percentage);
                    if (updateCb) updateCb(percentage);
                },
                onFinish: function () {
                    v3d.Preloader.prototype.onFinish.call(this);
                    if (finishCb) finishCb();
                },
            }
        );

        return new CustomPreloader();
    }

    /**
     * Modify the app's preloader to track the loading process in the Puzzles Editor.
     */
    function puzzlesEditorPreparePreloader(preloader) {
        // backward compatibility for loading new projects within the old Puzzles Editor
        if (
            v3d.PE.loadingUpdateCb !== undefined &&
            v3d.PE.loadingFinishCb !== undefined
        ) {
            var _onUpdate = preloader.onUpdate.bind(preloader);
            preloader.onUpdate = function (percentage) {
                _onUpdate(percentage);
                v3d.PE.loadingUpdateCb(percentage);
            };

            var _onFinish = preloader.onFinish.bind(preloader);
            preloader.onFinish = function () {
                _onFinish();
                v3d.PE.loadingFinishCb();
            };
        }
    }

    function initFullScreen() {
        var fsButton = document.getElementById("fullscreen_button");
        if (!fsButton) return;

        var container = document.getElementById(CONTAINER_ID);

        if (
            document.fullscreenEnabled ||
            document.webkitFullscreenEnabled ||
            document.mozFullScreenEnabled ||
            document.msFullscreenEnabled
        )
            fsButton.style.display = "inline";

        fsButton.addEventListener("click", function (event) {
            event.stopPropagation();
            if (
                document.fullscreenElement ||
                document.webkitFullscreenElement ||
                document.mozFullScreenElement ||
                document.msFullscreenElement
            ) {
                exitFullscreen();
            } else requestFullscreen(container);
        });

        function requestFullscreen(elem) {
            if (elem.requestFullscreen) elem.requestFullscreen();
            else if (elem.mozRequestFullScreen) elem.mozRequestFullScreen();
            else if (elem.webkitRequestFullscreen)
                elem.webkitRequestFullscreen();
            else if (elem.msRequestFullscreen) elem.msRequestFullscreen();
        }

        function exitFullscreen() {
            if (document.exitFullscreen) document.exitFullscreen();
            else if (document.mozCancelFullScreen)
                document.mozCancelFullScreen();
            else if (document.webkitExitFullscreen)
                document.webkitExitFullscreen();
            else if (document.msExitFullscreen) document.msExitFullscreen();
        }
    }

    function prepareExternalInterface(app) {
        // register functions in the app.ExternalInterface to call them from Puzzles, e.g:
        // app.ExternalInterface.myJSFunction = function() {
        //
        // }pChangeRoofColor
    }

    function runCode(app) {
        //This is default code,

        appGlobal = app;
        v3d.puzzles.procedures.pDefaultHide();
        // v3d.puzzles.procedures.pLameleShowHide();
        v3d.puzzles.procedures.pDefaultHideSupplyNotation();
        v3d.puzzles.procedures.pAssignDefaultMaterials();

        // generateNumbers(1.60066 , 0.182)
        builderFromInput();

        updateInputFields();

        v3d.puzzles.procedures.pCameraToCenterOfPergolaHelper();
        v3d.puzzles.procedures.pSetSpotLightInCenter();

        // just to fix low len
        if (globalInputHeight < 1400) {
            v3d.puzzles.procedures.pMovePlaneDownABit();
        }
        // turnLightsOn();

        // screenShot on button click
        app.ExternalInterface.downloadScreenshot = function (image) {
            var link = document.createElement("a");
            document.body.appendChild(link);
            link.setAttribute("download", "my_Original_screenshot.png");
            link.setAttribute("href", image);
            link.click();
        };

        app.ExternalInterface.recenterPergolaToARMAsh = function () {
            var meshes = window.appGlobal.scene.children;

            const elements = [];
            let center;
            for (let index = 0; index < meshes.length; index++) {
                if (
                    meshes[index].type == "Mesh" ||
                    meshes[index].type == "Group"
                ) {
                    if (meshes[index].name == "indicator_mesh") {
                        center = meshes[index].position;
                        console.log(center);
                    } else elements.push(meshes[index].name);
                }
            }
            console.log("meshes ARRAY", elements);

            const group = new THREE.Group();
            for (const name of elements) {
                const obj = window.appGlobal.scene.getObjectByName(name);
                if (obj) {
                    group.add(obj);
                }
            }
            console.log(group);

            group.position.x = center.x + globalInputLength / 500;
            group.position.y = center.y - globalInputWidth / 500;
            group.position.z = center.z - globalInputHeight / 500;

            group.scale.x = group.scale.x * 3;
            group.scale.y = group.scale.y * 3;
            group.scale.z = group.scale.z * 3;

            window.appGlobal.scene.add(group);
        };

        if (urlParams.get("print_screen") == "true") {
            makeScreenshots(app, urlParams);
        }
    }
}

function zoomIn() {
    var meshes = window.appGlobal.scene.children;

    const elements = [];
    let center;
    for (let index = 0; index < meshes.length; index++) {
        if (meshes[index].type == "Mesh" || meshes[index].type == "Group") {
            if (meshes[index].name == "indicator_mesh") {
                console.log("1");
                center = meshes[index].position;
                console.log(center);
            }
            if (
                meshes[index].name == "Plane" ||
                meshes[index].name == "Plane_background"
            ) {
                console.log("2");
                continue;
            } else {
                elements.push(meshes[index].name);
                console.log("2");
            }
        }
    }
    console.log("meshes ARRAY", elements);

    const group = new THREE.Group();
    for (const name of elements) {
        const obj = window.appGlobal.scene.getObjectByName(name);
        if (obj) {
            group.add(obj);
        }
    }
    console.log("group", group);

    group.position.x = center.x + 10;
    group.position.y = center.y - 3;
    group.position.z = center.z + 10;

    group.scale.x = group.scale.x * 5;
    group.scale.y = group.scale.y * 5;
    group.scale.z = group.scale.z * 5;

    window.appGlobal.scene.add(group);
}

const screenshot_types = [
    {
        event: "custom-screenshot-1",
        id: "screenshot1",
    },
    {
        event: "custom-screenshot-2",
        id: "screenshot2",
    },
    {
        event: "custom-screenshot-3",
        id: "screenshot3",
    },
];

function makeScreenshots(app) {
    // NOTE: Next lines are responsible for taking automatical in app
    // NOTE: screenshots that may be triggered via puppeter.

    // temp variables for moved camera position
    let x, y, z;

    // download first screenshot and move camera to second
    // position
    app.ExternalInterface.downloadScreenshot1 = function (data) {
        // in case we already have element added to view
        // we remove it
        document.getElementById(screenshot_types[0].id)?.remove();

        // create img element but do not show it view
        var img = document.createElement("img");
        img.setAttribute("id", screenshot_types[0].id);
        img.style = "display:none";
        img.setAttribute("src", data);
        document.body.appendChild(img);

        // dispatch event that current screenshot was
        // made
        window.dispatchEvent(new Event(screenshot_types[0].event));

        // set new camera positions
        x = 10;
        y = 3;
        z = -12;

        // update 3d model camera positions
        app.camera.position.x = x;
        app.camera.position.y = y;
        app.camera.position.z = z;
    };

    // download second screenshot and move camera to third
    // position
    app.ExternalInterface.downloadScreenshot2 = function (data) {
        // in case we already have element added to view
        // we remove it
        document.getElementById(screenshot_types[1].id)?.remove();

        // create img element but do not show it view
        var img = document.createElement("img");
        img.setAttribute("id", screenshot_types[1].id);
        img.style = "display:none";
        img.setAttribute("src", data);
        document.body.appendChild(img);

        // dispatch event that current screenshot was
        // made
        window.dispatchEvent(new Event(screenshot_types[1].event));

        // set new camera positions
        x = 10;
        y = 20;
        z = 9;

        // update 3d model camera positions
        app.camera.position.x = x;
        app.camera.position.y = y;
        app.camera.position.z = z;
    };

    // download third screenshot
    app.ExternalInterface.downloadScreenshot3 = function (data) {
        // in case we already have element added to view
        // we remove it
        document.getElementById(screenshot_types[2].id)?.remove();

        // create img element but do not show it view
        var img = document.createElement("img");
        img.setAttribute("id", screenshot_types[2].id);
        img.style = "display:none";
        img.setAttribute("src", data);
        document.body.appendChild(img);

        // dispatch event that current screenshot was
        // made
        window.dispatchEvent(new Event(screenshot_types[2].event));
    };

    // prepare for automaticall screenshots
    setTimeout(() => {
        // check if we need to make print screen, if not
        // return

        // prepare every position indicator if screenshot
        //was already made
        let alreadySet1 = false;
        let alreadySet2 = false;
        let alreadySet3 = false;

        // make interval which will listen every seconds
        // for any changes; beside that it will read written
        // x,y,z values and compare if change occured with
        // app.camera.position
        const interval = setInterval(() => {
            // check that we have working frame
            if (app.frame <= 1) {
                return;
            }

            // in case x, y and z are undefined then it means
            // that we must take frist screenshot
            if (
                (x == undefined || y == undefined || z == undefined) &&
                alreadySet1 == false
            ) {
                // call coresponding function
                v3d.puzzles.procedures.pScreenshot1();
                alreadySet1 = true;
            }

            // since every call on screenshot functions updates camera
            // and it also updates our local x, y, z values and if
            // current app (real) camera position is same as new position
            // then we proceeed with next screenshot; note that we are
            // using Math.round on real camera position since it may
            // happen that builder moves camera for few pixels which in
            // our case are not important
            else if (
                Math.round(app.camera.position.x) == x &&
                Math.round(app.camera.position.y) == y &&
                Math.round(app.camera.position.z) == z &&
                alreadySet2 == false
            ) {
                // call coresponding function
                v3d.puzzles.procedures.pScreenshot2();
                alreadySet2 = true;
            }
            // same explanation for third screenshot as is for previous
            // one
            else if (
                Math.round(app.camera.position.x) == x &&
                Math.round(app.camera.position.y) == y &&
                Math.round(app.camera.position.z) == z &&
                alreadySet3 == false
            ) {
                // call coresponding function
                v3d.puzzles.procedures.pScreenshot3();
                alreadySet3 = true;
            }

            // in case all screenshots are completed we clear interval
            if (
                alreadySet1 == true &&
                alreadySet2 == true &&
                alreadySet3 == true
            ) {
                clearInterval(interval);
            }
        }, 1000);
    }, 1000);
}

/**
 * Recognize input paramethers and build model
 */
function builderFromInput() {
    typeBuilder();

    widthBuilder();

    lengthBuilder();

    heightBuilder();

    defineRoofType(globalInputIstallationType);

    hideEnterier();

    structureColorBuidler();

    bladesColorBuilder();

    basicPolesBuider();

    additionalPolesBuilder();

    // type0WithoutStandardPoles();

    wallMountingBuilder();

    glassBuilder();

    zipBuilder();

    slideBuilder();

    waterEvacuationBuilder();

    powerSuppltyBuider();

    mororPositionBuilder();
}

//for now there is no instalation type in UI
function typeBuilder() {
    globalInputIstallationType;
    if (document.getElementById("installation_type") != undefined) {
        // globalInputLenghtMesureValue = document.getElementById("length").value;
        // globalInputLength = document.getElementById("length").value;
    } else if (urlParams.has("installation_type")) {
        globalInputIstallationType = urlParams.get("installation_type");
    }
}
/**
 * Builder - getting proper LENGTH value
 */

function lengthBuilder() {
    if (
        document.getElementById("length") != undefined ||
        globalLengthChanges == true
    ) {
        // globalInputLenghtMesureValue = document.getElementById("length").value;
        // globalInputLength = document.getElementById("length").value;
    } else if (urlParams.has("length")) {
        globalInputLenghtMesureValue = urlParams.get("length");
        globalInputLength = urlParams.get("length");
    }

    // globalInputLength =
    //     value != undefined ? value : document.getElementById("length").value;
    let closestLengthValue = 0;

    for (let i = 0; i < lengths.length; i++) {
        if (globalInputLength - lengths[i] < 91) {
            closestLengthValue = lengths[i];
            break;
        } else {
            closestLengthValue = lengths[lengths.length - 1];
        }
    }
    globalInputLength = closestLengthValue;
    v3d.puzzles.procedures.pSetPreviousYValues();
    v3d.puzzles.procedures.pMoveByYAxe((globalInputLength / 1000) * -1);
    v3d.puzzles.procedures.pScaleByYAxe(globalInputLength / 1000);
    // v3d.puzzles.procedures.pSetAreaList();
    // v3d.puzzles.procedures.pAreaLightsCopy();
}

/**
 * Builder - getting proper WIDTH value
 */
function widthBuilder() {
    if (
        document.getElementById("width") != undefined ||
        globalWidthChanges == true
    ) {
        // globalInputWidthMesureValue = document.getElementById("width").value;
        // globalInputWidth = document.getElementById("width").value;
    } else if (urlParams.has("width")) {
        globalInputWidthMesureValue = urlParams.get("width");
        globalInputWidth = urlParams.get("width");
    }
    let closestWidthValue = 0;
    let closestWidthIndex = 0;

    // scaling x (width) to the closest value in widhts array
    //calculating the losest value and index
    // for (let i = 0; globalInputWidth >= widths[i]; i++)? {

    for (let i = 0; i < widths.length; i++) {
        if (globalInputWidth - widths[i] < 91) {
            closestWidthValue = widths[i];
            closestWidthIndex = i;
            break;
        } else {
            closestWidthValue = widths[widths.length - 1];
            closestWidthIndex = i + 1;
        }
    }
    globalInputWidth = closestWidthValue;

    v3d.puzzles.procedures.pSetPreviousXValues();

    v3d.puzzles.procedures.pMoveByXAxe((globalInputWidth / 1000) * -1);
    v3d.puzzles.procedures.pScaleByXAxe(globalInputWidth / 1000);
    // v3d.puzzles.procedures.pLameleShowHide();
}

/**
 * Builder - getting proper HEIGHT value
 */

function heightBuilder() {
    globalInputHeight;
    globalInputHeightMesureValue;
    if (
        document.getElementById("height") != undefined ||
        globalHeightChanges == true
    ) {
        // globalInputHeightMesureValue = document.getElementById("height").value;
        // globalInputHeight = document.getElementById("height").value;
    } else if (urlParams.has("height")) {
        globalInputHeightMesureValue = urlParams.get("height");
        globalInputHeight = urlParams.get("height");
    }

    // let closestHeightValue = 0;

    // // scaling y (height) to the closest value in heights array
    // //calculating the losest value and index
    // for (let i = 0; i < heights.length; i++) {
    //     if (Math.abs(globalInputHeight - heights[i]) < 50) {
    //         globalInputHeight
    //         heights[i];
    //         closestHeightValue = heights[i];
    //         break;
    //     } else {
    //         closestHeightValue = heights[heights.length - 1];
    //     }
    // }

    // globalInputHeight = closestHeightValue;

    if (
        document.getElementById("additional_pole_0") != undefined ||
        globalAdditionalPolesArrayChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.get("additional_poles") != "[]" &&
        urlParams.get("additional_poles") != undefined
    ) {
        globalInputAdditionalPolesArray = JSON.parse(
            urlParams.get("additional_poles")
        );
    }
    //check if there is additional pole but globalHeight is <250
    if (
        globalInputHeight <= 250 &&
        (globalInputAdditionalPolesArray != [] ||
            globalInputAdditionalPolesArray != undefined)
    ) {
        for (
            let index = 0;
            index < globalInputAdditionalPolesArray.length;
            index++
        ) {
            let maxHeightOfAdditionalPole = 0;
            if (
                globalInputAdditionalPolesArray[index].height >
                maxHeightOfAdditionalPole
            ) {
                maxHeightOfAdditionalPole =
                    globalInputAdditionalPolesArray[index].height;
            }
            globalInputHeight = maxHeightOfAdditionalPole;
            globalInputHeightMesureValue = maxHeightOfAdditionalPole;
        }
    }
    //just hide plane if height is <250
    if (globalInputHeight <= 250) {
        globalInputHeightMesureValue = 0;
        globalInputHeight = 250;
        v3d.puzzles.procedures.pHidePlane();
    }

    v3d.puzzles.procedures.pSetPreviousZValues();
    v3d.puzzles.procedures.pSetPreviousGlassSlideHeightValue();

    v3d.puzzles.procedures.pSetSlideHeight(globalInputHeight / 1000 - 0.25);

    v3d.puzzles.procedures.pMoveByZAxe(globalInputHeight / 1000);
    v3d.puzzles.procedures.pScaleByZAxe();

    v3d.puzzles.procedures.pSetWallHeigth(globalInputHeight / 1000);
    v3d.puzzles.procedures.pSetGlassHeight(globalInputHeight / 1000);
    v3d.puzzles.procedures.pSetNotationHeight(globalInputHeight / 1000);
}

function type0WithoutStandardPoles() {
    if (
        document.getElementById("additional_pole_0") != undefined ||
        globalAdditionalPolesArrayChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.get("additional_poles") != "[]" &&
        urlParams.get("additional_poles") != undefined
    ) {
        globalInputAdditionalPolesArray = JSON.parse(
            urlParams.get("additional_poles")
        );
    }

    if (globalInputHeight == 0) {
        v3d.puzzles.procedures.pHidePlane();
        globalInputHeightMesureValue = 0;
        globalInputHeight = 250;
    }
    if (globalInputHeight <= 250) {
        if (globalInputAdditionalPolesArray != []) {
            for (
                let index = 0;
                index < globalInputAdditionalPolesArray.length;
                index++
            ) {
                let maxHeightOfAdditionalPole = 0;
                if (
                    globalInputAdditionalPolesArray[index].height >
                    maxHeightOfAdditionalPole
                ) {
                    maxHeightOfAdditionalPole =
                        globalInputAdditionalPolesArray[index].height;
                }
                globalInputHeight = maxHeightOfAdditionalPole;
                globalInputHeightMesureValue = maxHeightOfAdditionalPole;
            }
        } else {
            globalInputHeightMesureValue = 0;
            globalInputHeight = 250;
        }
    }
    // heightBuilder();
}

/**
 * Builder - defining the roof type -8 direction of roof
 */
function defineRoofType(typeNumber) {
    if (typeNumber == "Type4" || typeNumber == "Type5") {
        v3d.puzzles.procedures.pLameleShowHideOnXAxes();
        v3d.puzzles.procedures.pHideRoofLenght();
    } else {
        v3d.puzzles.procedures.pShowRoofLenght();
        v3d.puzzles.procedures.pLameleShowHide();
    }
}

function hideEnterier() {
    //hide by length
    if (globalInputLength <= 7000) {
        v3d.puzzles.procedures.pHideEnterierChillBeds();
        v3d.puzzles.procedures.pHideEnterierChillChair2();
    }
    if (globalInputLength <= 6000) {
        v3d.puzzles.procedures.pHideEnterierChillChairs();
    }
    if (globalInputLength <= 3700) {
        v3d.puzzles.procedures.pHideEnterierDinnerChair3();
    }
    if (globalInputLength <= 3200) {
        v3d.puzzles.procedures.pHideEnterierDinnerChair2And4();
    }
    if (globalInputLength <= 1600) {
        v3d.puzzles.procedures.pHideEnterierDinnerChairsAndTables();
    }

    //hide by width
    if (globalInputWidth <= 5700) {
        v3d.puzzles.procedures.pHideEnterierChillBeds2();
    }
    if (globalInputWidth <= 4500) {
        v3d.puzzles.procedures.pHideEnterierChillBedTable();
    }
    if (globalInputWidth <= 4200) {
        v3d.puzzles.procedures.pHideEnterierChillBeds1();
    }
    if (globalInputWidth <= 3900) {
        v3d.puzzles.procedures.pHideEnterierGrillAndKaktus();
    }
    if (globalInputWidth <= 2900) {
        v3d.puzzles.procedures.pHideEnterierDinnerChair4AndChair5();
    }
    if (globalInputWidth <= 2200) {
        v3d.puzzles.procedures.pHideEnterierDinnerChairsAndTables();
        v3d.puzzles.procedures.pHideEnterierChillChairs();
    }

    //hide by height
    if (globalInputHeight <= 1700) {
        v3d.puzzles.procedures.pHideEnterierChillBeds();
        v3d.puzzles.procedures.pHideEnterierChillChairs();
        v3d.puzzles.procedures.pHideEnterierDinnerChairsAndTables();
        v3d.puzzles.procedures.pHideEnterierDinnerChair2And4();
        v3d.puzzles.procedures.pHideEnterierGrillAndKaktus();
    }
}

/**
 * Builder - getting proper STRUCTURE COLOR value
 */

function structureColorBuidler() {
    let structureColor;
    if (
        urlParams.has("structure_color") &&
        globalStructureColorChanges == false
    ) {
        globalInputStructureColor = urlParams.get("structure_color");
    }

    if (RALColors[globalInputStructureColor] != undefined) {
        structureColor = RALColors[globalInputStructureColor].rgb;
    } else {
        structureColor = RALColors.RAL_9001.rgb;
    }
    v3d.puzzles.procedures.pChangeStructureColor(structureColor);
}

/**
 * Builder - getting proper BLADES COLOR value
 */

function bladesColorBuilder() {
    let bladesColor;
    if (urlParams.has("blades_color") && globalStructureColorChanges == false) {
        globalInputBladesColor = urlParams.get("blades_color");
    }

    if (RALColors[globalInputBladesColor] != undefined) {
        bladesColor = RALColors[globalInputBladesColor].rgb;
    } else {
        bladesColor = RALColors.RAL_9001.rgb;
    }
    v3d.puzzles.procedures.pChangeRoofColor(bladesColor);
}

/**
 * Builder - getting proper BASIC POLES value
 */

function basicPolesBuider() {
    if (
        document.getElementById("standard_pole_0") != undefined ||
        globalPolesArrayChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (urlParams.has("poles")) {
        globalInputPolesArray = JSON.parse(urlParams.get("poles"));
    }
    for (const element of globalInputPolesArray) {
        v3d.puzzles.procedures.pSetBasicPoleVisable(
            element.position,
            (element.height - 250) / 1000
        );
    }
}
/**
 * Builder - getting proper ADDITIONAL POLES value
 */

function additionalPolesBuilder() {
    let basicPoleHeight;

    if (
        document.getElementById("additional_pole_0") != undefined ||
        globalAdditionalPolesArrayChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.get("additional_poles") != "[]" &&
        urlParams.get("additional_poles") != undefined
    ) {
        globalInputAdditionalPolesArray = JSON.parse(
            urlParams.get("additional_poles")
        );
    }

    if (globalInputPolesArray.length == 0) {
        globalInputPolesArrayEmpty = true;
        basicPoleHeight = 2.5;
    }

    for (let i = 0; i < globalInputAdditionalPolesArray.length; i++) {
        let direction = globalInputAdditionalPolesArray[i].position;
        let distance =
            globalInputAdditionalPolesArray[i].distance_to_left / 1000;
        let height = globalInputAdditionalPolesArray[i].height / 1000 - 0.25;

        if ("P1-P2" == globalInputAdditionalPolesArray[i].position) {
            // if (urlParams.has("poles")) {
            //     globalInputPolesArray.forEach((element) => {
            //         if (element.position == "P1") {
            //             h = element.height;
            //         }
            //     });
            // } else if (urlParams.has("height")) {
            //     h = urlParams.get("height");
            // } else {
            //     h = 2200;
            // }

            // additionaPoleHeightScale =
            //     globalInputAdditionalPolesArray[i].height / h;
            if (globalInputPolesArrayEmpty == false) {
                basicPoleHeight = globalInputPolesArray[0].height / 1000 - 0.25;
            }
            v3d.puzzles.procedures.pCreateAdditonalPoleP1_P2(
                distance,
                height,
                basicPoleHeight
            );
        }
        if ("P1-P3" == globalInputAdditionalPolesArray[i].position) {
            // if (urlParams.has("poles")) {
            //     globalInputPolesArray.forEach((element) => {
            //         if (element.position == "P1") {
            //             h = element.height;
            //         }
            //     });
            // } else if (urlParams.has("height")) {
            //     h = urlParams.get("height");
            // } else {
            //     h = 2200;
            // }

            // additionaPoleHeightScale =
            //     globalInputAdditionalPolesArray[i].height / h;
            if (globalInputPolesArrayEmpty == false) {
                basicPoleHeight = globalInputPolesArray[0].height / 1000 - 0.25;
            }
            v3d.puzzles.procedures.pCreateAdditonalPoleP1_P3(
                -distance,
                height,
                basicPoleHeight
            );
        }
        if ("P2-P4" == globalInputAdditionalPolesArray[i].position) {
            // if (urlParams.has("poles")) {
            //     globalInputPolesArray.forEach((element) => {
            //         if (element.position == "P2") {
            //             h = element.height;
            //         }
            //     });
            // } else if (urlParams.has("height")) {
            //     h = urlParams.get("height");
            // } else {
            //     h = 2200;
            // }
            // additionaPoleHeightScale =
            //     globalInputAdditionalPolesArray[i].height / h;

            if (globalInputPolesArrayEmpty == false) {
                basicPoleHeight = globalInputPolesArray[0].height / 1000 - 0.25;
            }

            v3d.puzzles.procedures.pCreateAdditonalPoleP2_P4(
                distance,
                height,
                basicPoleHeight
            );
        }
        if ("P3-P4" == globalInputAdditionalPolesArray[i].position) {
            // if (urlParams.has("poles")) {
            //     globalInputPolesArray.forEach((element) => {
            //         if (element.position == "P3") {
            //             h = element.height;
            //         }
            //     });
            // } else if (urlParams.has("height")) {
            //     h = urlParams.get("height");
            // } else {
            //     h = 2200;
            // }
            // additionaPoleHeightScale =
            //     globalInputAdditionalPolesArray[i].height / h;
            if (globalInputPolesArrayEmpty == false) {
                basicPoleHeight = globalInputPolesArray[0].height / 1000 - 0.25;
            }

            v3d.puzzles.procedures.pCreateAdditonalPoleP3_P4(
                distance,
                height,
                basicPoleHeight
            );
        }
    }
    // }
}

// function which deletes p1-p2 if we already have P1-#1 in url
function deleteWholeSideIfNeeded(arrayToDelete) {
    let additionalPolesPosition;
    let wallPosition;

    for (let index = 0; index < arrayToDelete.length; index++) {
        wallPosition = arrayToDelete[index].position;
        if (wallPosition == "P1-P2") {
            for (let i = 0; i < globalInputAdditionalPolesArray.length; i++) {
                additionalPolesPosition =
                    globalInputAdditionalPolesArray[i].position;
                if (additionalPolesPosition == wallPosition) {
                    arrayToDelete.splice(index, 1);
                    index--;
                    break;
                }
            }
        } else if (wallPosition == "P1-P3") {
            for (let j = 0; j < globalInputAdditionalPolesArray.length; j++) {
                additionalPolesPosition =
                    globalInputAdditionalPolesArray[j].position;
                if (additionalPolesPosition == wallPosition) {
                    arrayToDelete.splice(index, 1);
                    index--;
                    break;
                }
            }
        } else if (wallPosition == "P2-P4") {
            for (let k = 0; k < globalInputAdditionalPolesArray.length; k++) {
                additionalPolesPosition =
                    globalInputAdditionalPolesArray[k].position;
                if (additionalPolesPosition == wallPosition) {
                    arrayToDelete.splice(index, 1);
                    index--;

                    break;
                }
            }
        } else if (wallPosition == "P3-P4") {
            for (let o = 0; o < globalInputAdditionalPolesArray.length; o++) {
                additionalPolesPosition =
                    globalInputAdditionalPolesArray[o].position;
                if (additionalPolesPosition == wallPosition) {
                    arrayToDelete.splice(index, 1);
                    index--;

                    break;
                }
            }
        }
    }
}

/**
 * Builder - getting proper WALL value`
 */
function wallMountingBuilder() {
    if (
        document.getElementById("wallMountingPosition_0") != undefined ||
        globalWallMountingArrayChanges == true ||
        globalPolesArrayChanges == true ||
        globalAdditionalPolesArrayChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.get("wall_mounting") != "[]" &&
        urlParams.get("wall_mounting") != undefined
    ) {
        globalInputWallMountingArray = JSON.parse(
            urlParams.get("wall_mounting")
        );
    }

    deleteWholeSideIfNeeded(globalInputWallMountingArray);

    v3d.puzzles.procedures.pMoveWallOverTheEdgeDown();
    v3d.puzzles.procedures.pMoveWallOverTheEdgeLeft();
    for (let i = 0; i < globalInputWallMountingArray.length; i++) {
        let wallMountingWords = [];
        let wallMountingLetters = [];
        let wallFullHeight;

        wallMountingWords = globalInputWallMountingArray[i].position.split("-");
        wallMountingLetters =
            globalInputWallMountingArray[i].position.split("");
        wallFullHeight = globalInputWallMountingArray[i].full_height;

        let wallDirection;
        let additionalWallStart;
        let additionalWallEnd;
        let poleDistance;
        let poleDistance2; // need in case # - #

        /**
         * Wall mounting checkiong from url
         */

        // wall mounting from # - P
        if (wallMountingLetters[0] == "#" && wallMountingLetters[4] != "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[1] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[1] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[1] - 1
                ].position.split("-")[1];
            poleDistance =
                globalInputAdditionalPolesArray[wallMountingLetters[1] - 1]
                    .distance_to_left;
        }
        // wall mounting p-#
        if (wallMountingLetters[3] == "#" && wallMountingLetters[0] != "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[4] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[4] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[4] - 1
                ].position.split("-")[1];

            poleDistance =
                globalInputAdditionalPolesArray[wallMountingLetters[4] - 1]
                    .distance_to_left;
        }
        // wall mounting # - #
        if (wallMountingLetters[0] == "#" && wallMountingLetters[3] == "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[4] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[1] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    wallMountingLetters[4] - 1
                ].position.split("-")[1];

            poleDistance =
                globalInputAdditionalPolesArray[wallMountingLetters[1] - 1]
                    .distance_to_left;
            poleDistance2 =
                globalInputAdditionalPolesArray[wallMountingLetters[4] - 1]
                    .distance_to_left;
        }

        /**
         * Wall P1-P2
         */
        // p1-p2 full size wall
        if (wallMountingWords[0] == "P1" && wallMountingWords[1] == "P2") {
            v3d.puzzles.procedures.pCreateWallMountingP1_P2(
                globalInputLength / 1000,
                wallFullHeight
            );
        }

        //(p1-#1... direction p2)
        if (
            wallMountingWords[0] == "P1" &&
            wallMountingLetters[3] == "#" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingP1_X_directionP2(
                poleDistance / -1000,
                wallFullHeight
            );
        }
        //(#2-p2...from p1, otherway)
        if (
            wallMountingLetters[0] == "#" &&
            wallMountingWords[1] == "P2" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingX_P2_FromP1(
                poleDistance / 1000,
                wallFullHeight
            );
        }
        //(#2-#3... p1-p2)
        if (
            wallMountingLetters[0] == "#" &&
            wallMountingLetters[3] == "#" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingX_X_FromP1_P2(
                poleDistance / 1000,
                poleDistance2 / 1000,
                wallFullHeight
            );
        }

        /**
         * wall P1-P3
         */
        // p1-p3 full size wall
        if (wallMountingWords[0] == "P1" && wallMountingWords[1] == "P3") {
            v3d.puzzles.procedures.pCreateWallMountingP1_P3(
                globalInputWidth / 1000,
                wallFullHeight
            );
        }
        //(p1-#1... direction p3)
        if (
            wallMountingWords[0] == "P1" &&
            wallMountingLetters[3] == "#" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingP1_X_directionP3(
                poleDistance / -1000,
                wallFullHeight
            );
        }
        //(#1-p3...from p1, otherway)
        if (
            wallMountingLetters[0] == "#" &&
            wallMountingWords[1] == "P3" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingX_P3_FromP1(
                poleDistance / 1000,
                wallFullHeight
            );
        }
        //(#2-#3... p1-p3)
        if (
            wallMountingLetters[0] == "#" &&
            wallMountingLetters[3] == "#" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingX_X_FromP1_P3(
                poleDistance / 1000,
                poleDistance2 / 1000,
                wallFullHeight
            );
        }

        /**
         * Wall P2-P4
         */
        //p2-p4 full size
        if (wallMountingWords[0] == "P2" && wallMountingWords[1] == "P4") {
            v3d.puzzles.procedures.pCreateWallMountingP2_P4(
                globalInputWidth / 1000,
                wallFullHeight
            );
        }
        //(p2-#1... direction p4)

        if (
            wallMountingWords[0] == "P2" &&
            wallMountingLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingP2_X_directionP4(
                poleDistance / -1000,
                wallFullHeight
            );
        }
        //(#1-p4...from p2, otherway)
        if (
            wallMountingLetters[0] == "#" &&
            wallMountingWords[1] == "P4" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingX_P4_FromP2(
                poleDistance / 1000,
                wallFullHeight
            );
        }
        //(#2-#3... p2-p4)
        if (
            wallMountingLetters[0] == "#" &&
            wallMountingLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingX_X_FromP2_P4(
                poleDistance / 1000,
                poleDistance2 / 1000,
                wallFullHeight
            );
        }

        /**
         * wall P3-P4
         */
        // p3-p4 full size wall
        if (wallMountingWords[0] == "P3" && wallMountingWords[1] == "P4") {
            v3d.puzzles.procedures.pCreateWallMountingFromP3_P4(
                globalInputLength / 1000,
                wallFullHeight
            );
        }
        //(p3-#1... direction p4)
        if (
            wallMountingWords[0] == "P3" &&
            wallMountingLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingP3_X_directionP4(
                poleDistance / -1000,
                wallFullHeight
            );
        }
        //(#2-p4...from p3, otherway)
        if (
            wallMountingLetters[0] == "#" &&
            wallMountingWords[1] == "P4" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingX_P4_FromP3(
                poleDistance / 1000,
                wallFullHeight
            );
        }
        //(#2-#3... p3-p4)
        if (
            wallMountingLetters[0] == "#" &&
            wallMountingLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateWallMountingX_X_FromP3_P4(
                poleDistance / 1000,
                poleDistance2 / 1000,
                wallFullHeight
            );
        }
    }
}

/**
 * Builder - getting proper GLASS value
 */

function glassBuilder() {
    if (
        document.getElementById("glassPosition_0") != undefined ||
        globalWallGlassArrayChanges == true ||
        globalPolesArrayChanges == true ||
        globalAdditionalPolesArrayChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.has("glass") != "[]" &&
        urlParams.get("glass") != undefined
    ) {
        globalInputGlassArray = JSON.parse(urlParams.get("glass"));
    }
    let glassWords = [];
    let glassLetters = [];
    let glassDoorknob;
    deleteWholeSideIfNeeded(globalInputGlassArray);

    for (let i = 0; i < globalInputGlassArray.length; i++) {
        glassWords = globalInputGlassArray[i].position.split("-");
        glassLetters = globalInputGlassArray[i].position.split("");
        glassDoorknob = globalInputGlassArray[i].type;

        let wallDirection;
        let additionalWallStart;
        let additionalWallEnd;
        let poleDistance;
        let poleDistance2; // need in case # - #

        /**
         * Glass checkiong from url
         */
        // Glass from # - P
        if (glassLetters[0] == "#" && glassLetters[4] != "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    glassLetters[1] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    glassLetters[1] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    glassLetters[1] - 1
                ].position.split("-")[1];
            poleDistance =
                globalInputAdditionalPolesArray[glassLetters[1] - 1]
                    .distance_to_left;
        }
        // Glass p-#
        if (glassLetters[3] == "#" && glassLetters[0] != "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    glassLetters[4] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    glassLetters[4] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    glassLetters[4] - 1
                ].position.split("-")[1];

            poleDistance =
                globalInputAdditionalPolesArray[glassLetters[4] - 1]
                    .distance_to_left;
        }
        // Glass # - #
        if (glassLetters[0] == "#" && glassLetters[3] == "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    glassLetters[4] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    glassLetters[1] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    glassLetters[4] - 1
                ].position.split("-")[1];

            poleDistance =
                globalInputAdditionalPolesArray[glassLetters[1] - 1]
                    .distance_to_left;
            poleDistance2 =
                globalInputAdditionalPolesArray[glassLetters[4] - 1]
                    .distance_to_left;
        }

        /**
         * Glass P1-P2
         */
        // p1-p2 full size glas
        if (glassWords[0] == "P1" && glassWords[1] == "P2") {
            v3d.puzzles.procedures.pCreateGlassP1_P2(globalInputLength / 1000);
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    globalInputLength / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP1_P2(0.4);
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    globalInputLength / 2000 - 0.2
                );
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    globalInputLength / 2000 + 0.2
                );
            }
        }

        //(p1-#1... direction p2)
        if (
            glassWords[0] == "P1" &&
            glassLetters[3] == "#" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pCreateGlassP1_X_directionP2(
                poleDistance / -1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    poleDistance / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP1_P2(0.4);
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    poleDistance / 2000 - 0.2
                );
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    poleDistance / 2000 + 0.2
                );
            }
        }
        //(#2-p2...from p1, otherway)
        if (
            glassLetters[0] == "#" &&
            glassWords[1] == "P2" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pCreateGlassX_P2_FromP1(poleDistance / 1000);
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    globalInputLength / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    poleDistance / 1000 + 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    (poleDistance + (globalInputLength - poleDistance) / 2) /
                        1000 -
                        0.2
                );
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    (poleDistance + (globalInputLength - poleDistance) / 2) /
                        1000 +
                        0.2
                );
            }
        }
        //(#2-#3... p1-p2)
        if (
            glassLetters[0] == "#" &&
            glassLetters[3] == "#" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pCreateGlassX_X_FromP1_P2(
                poleDistance / 1000,
                poleDistance2 / 1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    poleDistance2 / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    poleDistance / 1000 + 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    (poleDistance + (poleDistance2 - poleDistance) / 2) / 1000 -
                        0.2
                );
                v3d.puzzles.procedures.pDoorknobP1_P2(
                    (poleDistance + (poleDistance2 - poleDistance) / 2) / 1000 +
                        0.2
                );
            }
        }

        /**
         * Glass P1-P3
         */
        // p1-p3 full size glass
        if (glassWords[0] == "P1" && glassWords[1] == "P3") {
            v3d.puzzles.procedures.pCreateGlassP1_P3(globalInputWidth / -1000);
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    globalInputWidth / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP1_P3(0.4);
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    globalInputWidth / 2000 - 0.2 / 2000 - 0.2
                );
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    globalInputWidth / 2000 + 0.2
                );
            }
        }
        //(p1-#1... direction p3)
        if (
            glassWords[0] == "P1" &&
            glassLetters[3] == "#" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pCreateGlassP1_X_directionP3(
                poleDistance / -1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    poleDistance / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP1_P3(0.4);
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    poleDistance / 2000 - 0.2
                );
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    poleDistance / 2000 + 0.2
                );
            }
        }
        //(#1-p3...from p1, otherway)
        if (
            glassLetters[0] == "#" &&
            glassWords[1] == "P3" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pCreateGlassX_P3_FromP1(poleDistance / 1000);
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    globalInputWidth / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    poleDistance / 1000 + 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    (poleDistance + (globalInputWidth - poleDistance) / 2) /
                        1000 -
                        0.2
                );
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    (poleDistance + (globalInputWidth - poleDistance) / 2) /
                        1000 +
                        0.2
                );
            }
        }
        //(#2-#3... p1-p3)
        if (
            glassLetters[0] == "#" &&
            glassLetters[3] == "#" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pCreateGlassX_X_FromP1_P3(
                poleDistance / 1000,
                poleDistance2 / 1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    poleDistance2 / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    poleDistance / 1000 + 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    (poleDistance + (poleDistance2 - poleDistance) / 2) / 1000 -
                        0.2
                );
                v3d.puzzles.procedures.pDoorknobP1_P3(
                    (poleDistance + (poleDistance2 - poleDistance) / 2) / 1000 +
                        0.2
                );
            }
        }

        /**
         * Glass P2-P4
         */
        //p2-p4 full size
        if (glassWords[0] == "P2" && glassWords[1] == "P4") {
            v3d.puzzles.procedures.pCreateGlassP2_P4(globalInputWidth / -1000);
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    globalInputWidth / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP2_P4(0.4);
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    globalInputWidth / 2000 - 0.2
                );
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    globalInputWidth / 2000 + 0.2
                );
            }
        }
        //(p2-#1... direction p4)
        if (
            glassWords[0] == "P2" &&
            glassLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateGlassP2_X_directionP4(
                poleDistance / -1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    poleDistance / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP2_P4(0.4);
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    poleDistance / 2000 - 0.2
                );
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    poleDistance / 2000 + 0.2
                );
            }
        }
        //(#1-p4...from p2, otherway)
        if (
            glassLetters[0] == "#" &&
            glassWords[1] == "P4" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateGlassX_P4_FromP2(poleDistance / 1000);
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    globalInputWidth / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    poleDistance / 1000 + 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    (poleDistance + (globalInputWidth - poleDistance) / 2) /
                        1000 -
                        0.2
                );
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    (poleDistance + (globalInputWidth - poleDistance) / 2) /
                        1000 +
                        0.2
                );
            }
        }
        //(#2-#3... p2-p4)
        if (
            glassLetters[0] == "#" &&
            glassLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateGlassX_X_FromP2_P4(
                poleDistance / 1000,
                poleDistance2 / 1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    poleDistance2 / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    poleDistance / 1000 + 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    (poleDistance + (poleDistance2 - poleDistance) / 2) / 1000 -
                        0.2
                );
                v3d.puzzles.procedures.pDoorknobP2_P4(
                    (poleDistance + (poleDistance2 - poleDistance) / 2) / 1000 +
                        0.2
                );
            }
        }
        /**
         * Glass P3-P4
         */
        // p3-p4 full size Glass
        if (glassWords[0] == "P3" && glassWords[1] == "P4") {
            v3d.puzzles.procedures.pCreateGlassFromP3_P4(
                globalInputWidth / 1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    globalInputLength / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP3_P4(0.4);
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    globalInputWidth / 1000 - 0.4 / 2000 - 0.2
                );
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    globalInputLength / 2000 + 0.2
                );
            }
        }
        //(p3-#1... direction p4)
        if (
            glassWords[0] == "P3" &&
            glassLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateGlassP3_X_directionP4(
                poleDistance / -1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    poleDistance / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP3_P4(0.4);
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    poleDistance / 2000 - 0.2
                );
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    poleDistance / 2000 + 0.2
                );
            }
        }
        //(#2-p4...from p3, otherway)
        if (
            glassLetters[0] == "#" &&
            glassWords[1] == "P4" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateGlassX_P4_FromP3(poleDistance / 1000);
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    globalInputLength / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    poleDistance / 1000 + 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    (poleDistance + (globalInputLength - poleDistance) / 2) /
                        1000 -
                        0.2
                );
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    (poleDistance + (globalInputLength - poleDistance) / 2) /
                        1000 +
                        0.2
                );
            }
        }
        //(#2-#3... p3-p4)
        if (
            glassLetters[0] == "#" &&
            glassLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pCreateGlassX_X_FromP3_P4(
                poleDistance / 1000,
                poleDistance2 / 1000
            );
            if (glassDoorknob == "ONE_GUIDE_STANDARD") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    poleDistance2 / 1000 - 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_REVERSE") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    poleDistance / 1000 + 0.4
                );
            }
            if (glassDoorknob == "ONE_GUIDE_FULL") {
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    (poleDistance + (poleDistance2 - poleDistance) / 2) / 1000 -
                        0.2
                );
                v3d.puzzles.procedures.pDoorknobP3_P4(
                    (poleDistance + (poleDistance2 - poleDistance) / 2) / 1000 +
                        0.2
                );
            }
        }
    }
    v3d.puzzles.procedures.pDoorknobHide();
}

/**
 * Builder - getting proper ZIP value
 */

function zipBuilder() {
    if (
        document.getElementById("zipPosition_0") != undefined ||
        globalZipArrayChanges == true ||
        globalPolesArrayChanges == true ||
        globalAdditionalPolesArrayChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (urlParams.has("zip") && urlParams.get("zip") != undefined) {
        globalInputZipArray = JSON.parse(urlParams.get("zip"));
    }
    let zipWords = [];
    let zipLetters = [];
    let zipCollors = [];
    let zipColor;
    deleteWholeSideIfNeeded(globalInputZipArray);

    for (let i = 0; i < globalInputZipArray.length; i++) {
        v3d.puzzles.procedures.pSetZipHeight();

        zipWords = globalInputZipArray[i].position.split("-");
        zipLetters = globalInputZipArray[i].position.split("");
        zipCollors = globalInputZipArray[i].color;
        if (RALColors[zipCollors] != undefined) {
            zipColor = RALColors[zipCollors].rgb;
        } else {
            zipColor = RALColors.RAL_9001.rgb;
        }

        // let globalInputAdditionalPolesArray = JSON.parse(
        //     urlParams.get("additional_poles")
        // );
        let wallDirection;
        let additionalWallStart;
        let additionalWallEnd;
        let poleDistance;
        let poleDistance2; // need in case # - #

        /**
         * zip checkiong from url
         */
        // zip from # - P
        if (zipLetters[0] == "#" && zipLetters[4] != "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    zipLetters[1] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    zipLetters[1] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    zipLetters[1] - 1
                ].position.split("-")[1];
            poleDistance =
                globalInputAdditionalPolesArray[zipLetters[1] - 1]
                    .distance_to_left;
        }
        // zip p-#
        if (zipLetters[3] == "#" && zipLetters[0] != "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    zipLetters[4] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    zipLetters[4] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    zipLetters[4] - 1
                ].position.split("-")[1];

            poleDistance =
                globalInputAdditionalPolesArray[zipLetters[4] - 1]
                    .distance_to_left;
        }
        // zip # - #
        if (zipLetters[0] == "#" && zipLetters[3] == "#") {
            wallDirection =
                globalInputAdditionalPolesArray[
                    zipLetters[4] - 1
                ].position.split("-")[1];
            additionalWallStart =
                globalInputAdditionalPolesArray[
                    zipLetters[1] - 1
                ].position.split("-")[0];
            additionalWallEnd =
                globalInputAdditionalPolesArray[
                    zipLetters[4] - 1
                ].position.split("-")[1];

            poleDistance =
                globalInputAdditionalPolesArray[zipLetters[1] - 1]
                    .distance_to_left;
            poleDistance2 =
                globalInputAdditionalPolesArray[zipLetters[4] - 1]
                    .distance_to_left;
        }

        /**
         * zip P1-P2
         */
        // p1-p2 full size glas
        if (zipWords[0] == "P1" && zipWords[1] == "P2") {
            v3d.puzzles.procedures.pSetZipP1_P2Color(zipColor);

            v3d.puzzles.procedures.pCreateZipP1_P2(globalInputWidth / 1000);
        }

        //(p1-#1... direction p2)
        if (
            zipWords[0] == "P1" &&
            zipLetters[3] == "#" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pSetZipP1_P2Color(zipColor);

            v3d.puzzles.procedures.pCreateZipP1_X_directionP2(
                poleDistance / -1000,
                zipColor
            );
        }
        //(#2-p2...from p1, otherway)
        if (
            zipLetters[0] == "#" &&
            zipWords[1] == "P2" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pSetZipP1_P2Color(zipColor);

            v3d.puzzles.procedures.pCreateZipX_P2_FromP1(poleDistance / 1000);
        }
        //(#2-#3... p1-p2)
        if (
            zipLetters[0] == "#" &&
            zipLetters[3] == "#" &&
            wallDirection == "P2" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P2"
        ) {
            v3d.puzzles.procedures.pSetZipP1_P2Color(zipColor);

            v3d.puzzles.procedures.pCreateZipX_X_FromP1_P2(
                poleDistance / 1000,
                poleDistance2 / 1000
            );
        }

        /**
         * zip P1-P3
         */
        // p1-p3 full size zip

        if (zipWords[0] == "P1" && zipWords[1] == "P3") {
            v3d.puzzles.procedures.pSetZipP1_P3Color(zipColor);

            v3d.puzzles.procedures.pCreateZipP1_P3(globalInputLength / -1000);
        }
        //(p1-#1... direction p3)
        if (
            zipWords[0] == "P1" &&
            zipLetters[3] == "#" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pSetZipP1_P3Color(zipColor);

            v3d.puzzles.procedures.pCreateZipP1_X_directionP3(
                poleDistance / -1000
            );
        }
        //(#1-p3...from p1, otherway)
        if (
            zipLetters[0] == "#" &&
            zipWords[1] == "P3" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pSetZipP1_P3Color(zipColor);

            v3d.puzzles.procedures.pCreateZipX_P3_FromP1(poleDistance / 1000);
        }
        //(#2-#3... p1-p3)
        if (
            zipLetters[0] == "#" &&
            zipLetters[3] == "#" &&
            wallDirection == "P3" &&
            additionalWallStart == "P1" &&
            additionalWallEnd == "P3"
        ) {
            v3d.puzzles.procedures.pSetZipP1_P3Color(zipColor);

            v3d.puzzles.procedures.pCreateZipX_X_FromP1_P3(
                poleDistance / 1000,
                poleDistance2 / 1000
            );
        }

        /**
         * zip P2-P4
         */
        //p2-p4 full size
        if (zipWords[0] == "P2" && zipWords[1] == "P4") {
            v3d.puzzles.procedures.pSetZipP2_P4Color(zipColor);

            v3d.puzzles.procedures.pCreateZipP2_P4(globalInputLength / -1000);
        }
        //(p2-#1... direction p4)
        if (
            zipWords[0] == "P2" &&
            zipLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pSetZipP2_P4Color(zipColor);

            v3d.puzzles.procedures.pCreateZipP2_X_directionP4(
                poleDistance / -1000
            );
        }
        //(#1-p4...from p2, otherway)
        if (
            zipLetters[0] == "#" &&
            zipWords[1] == "P4" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pSetZipP2_P4Color(zipColor);

            v3d.puzzles.procedures.pCreateZipX_P4_FromP2(poleDistance / 1000);
        }
        //(#2-#3... p2-p4)
        if (
            zipLetters[0] == "#" &&
            zipLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P2" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pSetZipP2_P4Color(zipColor);

            v3d.puzzles.procedures.pCreateZipX_X_FromP2_P4(
                poleDistance / 1000,
                poleDistance2 / 1000
            );
        }
        /**
         * zip P3-P4
         */
        // p3-p4 full size zip
        if (zipWords[0] == "P3" && zipWords[1] == "P4") {
            v3d.puzzles.procedures.pSetZipP3_P4Color(zipColor);

            v3d.puzzles.procedures.pCreateZipFromP3_P4(globalInputWidth / 1000);
        }
        //(p3-#1... direction p4)
        if (
            zipWords[0] == "P3" &&
            zipLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pSetZipP3_P4Color(zipColor);

            v3d.puzzles.procedures.pCreateZipP3_X_directionP4(
                poleDistance / -1000
            );
        }
        //(#2-p4...from p3, otherway)
        if (
            zipLetters[0] == "#" &&
            zipWords[1] == "P4" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pSetZipP3_P4Color(zipColor);

            v3d.puzzles.procedures.pCreateZipX_P4_FromP3(poleDistance / 1000);
        }
        //(#2-#3... p3-p4)
        if (
            zipLetters[0] == "#" &&
            zipLetters[3] == "#" &&
            wallDirection == "P4" &&
            additionalWallStart == "P3" &&
            additionalWallEnd == "P4"
        ) {
            v3d.puzzles.procedures.pSetZipP3_P4Color(zipColor);

            v3d.puzzles.procedures.pCreateZipX_X_FromP3_P4(
                poleDistance / 1000,
                poleDistance2 / 1000
            );
        }
    }
}

function getRandomNumber(min, max) {
    return Math.floor(Math.random() * (max - min) + min);
}

/**
 * Builder - getting proper SLIDE value 

 */

function slideBuilder() {
    if (
        document.getElementById("slidePosition_0") != undefined ||
        globalSlideArrayChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.has("sliding") &&
        urlParams.get("sliding") != undefined
    ) {
        globalInputSlideArray = JSON.parse(urlParams.get("sliding"));
    }
    deleteWholeSideIfNeeded(globalInputSlideArray);
    let slideWords = [];
    let slideWidth;
    let slideTexture;
    let slideTextrueImage;
    let slideLetters;
    let slideFromPole;
    let slideToPole;

    let slideStartingPointDistance;
    let slideEndingPointDistance;
    let slideRandStart;
    let slideRandEnd;
    let randomPostion;
    let slideNumberOfPanels;

    for (let i = 0; i < globalInputSlideArray.length; i++) {
        slideWords = globalInputSlideArray[i].position.split("-");
        slideLetters = globalInputSlideArray[i].position.split("");
        slideWidth = globalInputSlideArray[i].width;
        slideTexture = globalInputSlideArray[i].panel_type;
        slideNumberOfPanels = globalInputSlideArray[i].number_of_panels;

        slideStartingPointDistance = 0;
        // From P to P, length
        if (
            (slideWords[0] == "P1" && slideWords[1] == "P2") ||
            (slideWords[0] == "P3" && slideWords[1] == "P4")
        ) {
            slideFromPole = slideWords[0];
            slideToPole = slideWords[1];
            // slideStartingPointDistance = 0;
            slideEndingPointDistance = globalInputLength - slideWidth / 10;
            slideStartingPointDistance = 0;

            slideRandStart = slideWidth;
        }

        // From P to P, width
        if (
            (slideWords[0] == "P1" && slideWords[1] == "P3") ||
            (slideWords[0] == "P2" && slideWords[1] == "P4")
        ) {
            slideFromPole = slideWords[0];
            slideToPole = slideWords[1];
            // slideStartingPointDistance = 0;
            slideEndingPointDistance = globalInputWidth - slideWidth / 10;
            slideStartingPointDistance = 0;

            slideRandStart = slideWidth;
        }
        // From # to P
        if (slideLetters[0] == "#" && slideLetters[3] == "P") {
            slideFromPole =
                globalInputAdditionalPolesArray[
                    slideLetters[1] - 1
                ].position.split("-")[0];
            slideToPole = slideWords[1];
            slideStartingPointDistance =
                globalInputAdditionalPolesArray[slideLetters[1] - 1]
                    .distance_to_left;
            slideRandStart = slideStartingPointDistance + slideWidth;

            // if (slideLetters[3] == "#") {
            //     slideEndingPointDistance =
            //         globalInputAdditionalPolesArray[slideLetters[4] - 1]
            //             .distance_to_left;
            //     slideToPole =
            //         globalInputAdditionalPolesArray[
            //             slideLetters[4] - 1
            //         ].position.split("-")[1];
        }

        // width
        if (
            (slideFromPole == "P1" && slideWords[1] == "P2") ||
            (slideFromPole == "P3" && slideWords[1] == "P4")
        ) {
            slideEndingPointDistance = globalInputLength - slideWidth / 10;
        }

        // lenght
        if (
            (slideFromPole == "P1" && slideWords[1] == "P3") ||
            (slideFromPole == "P2" && slideWords[1] == "P4")
        ) {
            slideEndingPointDistance = globalInputWidth - slideWidth / 10;
            // \ }
        }

        // from P to #
        if (slideLetters[0] == "P" && slideLetters[3] == "#") {
            slideFromPole = slideWords[0];
            slideStartingPointDistance = 0;
            slideToPole =
                globalInputAdditionalPolesArray[
                    slideLetters[4] - 1
                ].position.split("-")[1];
            slideEndingPointDistance =
                globalInputAdditionalPolesArray[slideLetters[4] - 1]
                    .distance_to_left -
                slideWidth / 10;
            slideRandStart = slideWidth;

            // if (slideLetters[0] == "#") {
            //     slideFromPole =
            //         globalInputAdditionalPolesArray[
            //             slideLetters[1] - 1
            //         ].position.split("-")[0];
            //     slideStartingPointDistance =
            //         globalInputAdditionalPolesArray[slideLetters[4] - 1]
            //             .distance_to_left;
            //     slideRandStart = slideStartingPointDistance;
            // } else {
            //     if (block == true) {
            //         slideStartingPointDistance = 0;
            //         slideRandStart = 0;
            //         block = false;
            //     }
            // }
        }

        // from # to #
        if (slideLetters[0] == "#" && slideLetters[3] == "#") {
            slideFromPole =
                globalInputAdditionalPolesArray[
                    slideLetters[1] - 1
                ].position.split("-")[0];
            slideToPole =
                globalInputAdditionalPolesArray[
                    slideLetters[4] - 1
                ].position.split("-")[1];
            slideStartingPointDistance =
                globalInputAdditionalPolesArray[slideLetters[1] - 1]
                    .distance_to_left;
            slideEndingPointDistance =
                globalInputAdditionalPolesArray[slideLetters[4] - 1]
                    .distance_to_left -
                slideWidth / 10;
            slideRandStart = slideStartingPointDistance + slideWidth;
        }

        if (slideNumberOfPanels == undefined) {
            slideNumberOfPanels = 1;
        }

        //p1-p2

        if (slideFromPole == "P1" && slideToPole == "P2") {
            if (slideTexture == "WOOD") {
                slideTextrueImage = "slide_wood_texture_001.jpg";
            } else if (slideTexture == "ALU") {
                slideTextrueImage = "slide_aluminium_textureLQ_001.jpg";
            }
            slideWidth;

            if (globalOldScaleValueP1_P2 == undefined) {
                globalOldScaleValueP1_P2 = 1;
            }
            for (let index = 1; index < slideNumberOfPanels; index++) {
                if (index == 1) {
                    slideFromPole;
                    slideToPole;
                    slideStartingPointDistance;
                    slideRandEnd;
                    slideRandStart;
                    v3d.puzzles.procedures.pCreateSlideP1_P2(
                        slideStartingPointDistance / 1000,
                        slideWidth / 1000,
                        slideTextrueImage,
                        globalOldScaleValueP1_P2
                    );
                    globalOldScaleValueP1_P2 = slideWidth / 1000; // useless for now, because it recrates every time starting model,
                    //but this is way to do it if we would not recrate it from 0
                }
                slideRandEnd =
                    slideEndingPointDistance -
                    (slideNumberOfPanels - index) * slideWidth -
                    slideWidth / 10;
                if (index == slideNumberOfPanels) {
                    slideRandEnd =
                        slideEndingPointDistance -
                        (slideWidth * -slideWidth) / 10;
                }
                randomPostion = getRandomNumber(slideRandStart, slideRandEnd);

                v3d.puzzles.procedures.pCreateSlideP1_P2(
                    randomPostion / 1000,
                    slideWidth / 1000,
                    slideTextrueImage,
                    globalOldScaleValueP1_P2
                );
                globalOldScaleValueP1_P2 = slideWidth / 1000; // useless for now, because it recrates every time starting model,
                //but this is way to do it if we would not recrate it from 0

                slideRandStart = randomPostion + slideWidth;
            }
        }

        //p1-p3
        if (slideFromPole == "P1" && slideToPole == "P3") {
            if (slideTexture == "WOOD") {
                slideTextrueImage = "slide_wood_texture_002.jpg";
            } else if (slideTexture == "ALU") {
                slideTextrueImage = "slide_aluminium_textureLQ_002.jpg";
            }
            if (globalOldScaleValueP1_P3 == undefined) {
                globalOldScaleValueP1_P3 = 1;
            }

            for (let index = 1; index < slideNumberOfPanels; index++) {
                if (index == 1) {
                    slideStartingPointDistance; //= 0;
                    v3d.puzzles.procedures.pCreateSlideP1_P3(
                        slideStartingPointDistance / -1000,
                        slideWidth / 1000,
                        slideTextrueImage,
                        globalOldScaleValueP1_P3
                    );
                    globalOldScaleValueP1_P3 = slideWidth / 1000; // useless for now, because it recrates every time starting model,
                    //but this is way to do it if we would not recrate it from 0
                }
                slideRandEnd =
                    slideEndingPointDistance -
                    (slideNumberOfPanels - index) * slideWidth -
                    slideWidth / 10;
                if (index == slideNumberOfPanels) {
                    slideRandEnd =
                        slideEndingPointDistance - slideWidth - slideWidth / 10;
                }
                randomPostion = getRandomNumber(slideRandStart, slideRandEnd);

                v3d.puzzles.procedures.pCreateSlideP1_P3(
                    randomPostion / -1000,
                    slideWidth / 1000,
                    slideTextrueImage,
                    globalOldScaleValueP1_P3
                );
                globalOldScaleValueP1_P3 = slideWidth / 1000; // useless for now, because it recrates every time starting model,
                //but this is way to do it if we would not recrate it from 0

                slideRandStart = randomPostion + slideWidth;
            }
        }
        //p2-p4
        slideFromPole;
        slideToPole;
        if (slideFromPole == "P2" && slideToPole == "P4") {
            if (slideTexture == "WOOD") {
                slideTextrueImage = "slide_wood_texture_003.jpg";
            } else if (slideTexture == "ALU") {
                slideTextrueImage = "slide_aluminium_textureLQ_003.jpg";
            }
            if (globalOldScaleValueP2_P4 == undefined) {
                globalOldScaleValueP2_P4 = 1;
            }

            for (let index = 1; index < slideNumberOfPanels; index++) {
                if (index == 1) {
                    slideStartingPointDistance; //= 0;
                    v3d.puzzles.procedures.pCreateSlideP2_P4(
                        slideStartingPointDistance / -1000,
                        slideWidth / 1000,
                        slideTextrueImage,
                        globalOldScaleValueP2_P4
                    );
                    globalOldScaleValueP2_P4 = slideWidth / 1000; // useless for now, because it recrates every time starting model,
                    //but this is way to do it if we would not recrate it from 0. One thing that comes to my mind also is that scale factor (factor = 0.452381, not value) should be replaced with new one.
                }

                slideRandEnd =
                    slideEndingPointDistance -
                    (slideNumberOfPanels - index) * slideWidth -
                    slideWidth / 10;
                if (index == slideNumberOfPanels) {
                    slideRandEnd =
                        slideEndingPointDistance - slideWidth - slideWidth / 10;
                }
                randomPostion = getRandomNumber(slideRandStart, slideRandEnd);

                v3d.puzzles.procedures.pCreateSlideP2_P4(
                    randomPostion / -1000,
                    slideWidth / 1000,
                    slideTextrueImage,
                    globalOldScaleValueP2_P4
                );
                globalOldScaleValueP2_P4 = slideWidth / 1000; // useless for now, because it recrates every time starting model,
                //but this is way to do it if we would not recrate it from 0. One thing that comes to my mind also is that scale factor (factor = 0.452381, not value) should be replaced with new one.
                slideRandStart = randomPostion + slideWidth;
            }
        }

        //p3-p4
        if (slideFromPole == "P3" && slideToPole == "P4") {
            if (slideTexture == "WOOD") {
                slideTextrueImage = "slide_wood_texture_004.jpg";
            } else if (slideTexture == "ALU") {
                slideTextrueImage = "slide_aluminium_textureLQ_004.jpg";
            }
            if (globalOldScaleValueP3_P4 == undefined) {
                globalOldScaleValueP3_P4 = 1;
            }

            for (let index = 1; index < slideNumberOfPanels; index++) {
                if (index == 1) {
                    slideStartingPointDistance; //= 0;

                    v3d.puzzles.procedures.pCreateSlideP3_P4(
                        slideStartingPointDistance / 1000,
                        slideWidth / 1000,
                        slideTextrueImage,
                        globalOldScaleValueP3_P4
                    );
                    globalOldScaleValueP3_P4 = slideWidth / 1000; // useless for now, because it recrates every time starting model,
                    //but this is way to do it if we would not recrate it from 0
                }
                slideRandEnd =
                    slideEndingPointDistance -
                    (slideNumberOfPanels - index) * slideWidth -
                    slideWidth / 10;
                if (index == slideNumberOfPanels) {
                    slideRandEnd =
                        slideEndingPointDistance - slideWidth - slideWidth / 10;
                }
                randomPostion = getRandomNumber(slideRandStart, slideRandEnd);

                v3d.puzzles.procedures.pCreateSlideP3_P4(
                    randomPostion / 1000,
                    slideWidth / 1000,
                    slideTextrueImage,
                    globalOldScaleValueP3_P4
                );
                globalOldScaleValueP3_P4 = slideWidth / 1000; // useless for now, because it recrates every time starting model,
                //but this is way to do it if we would not recrate it from 0

                slideRandStart = randomPostion + slideWidth;
            }
        }
    }
}

/**
 * Builder - getting proper WATER EVACUATOION value
 */

function waterEvacuationBuilder() {
    if (
        document.getElementById("water_evacuation_position_0") != undefined ||
        globalWaterEvacuationChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.has("water_evacuation") &&
        urlParams.get("water_evacuation") != undefined
    ) {
        let tempWaterEvacuation = JSON.parse(urlParams.get("water_evacuation"));
        for (
            let index = 0;
            index < globalInputWaterEvacuation.length;
            index++
        ) {
            for (let i = 0; i < tempWaterEvacuation.length; i++) {
                if (
                    globalInputWaterEvacuation[index].key ==
                    tempWaterEvacuation[i].position.split(" ")[1]
                ) {
                    globalInputWaterEvacuation[index].checked = true;
                }
            }
        }

        // globalInputWaterEvacuation = JSON.parse(
        //     urlParams.get("water_evacuation")
        // );
    }
    let waterEvacuationPosition;
    let waterEvacuationChacker;

    for (let i = 0; i < globalInputWaterEvacuation.length; i++) {
        waterEvacuationPosition =
            globalInputWaterEvacuation[i].position.split(" ")[1];
        waterEvacuationChacker = globalInputWaterEvacuation[i].checked;

        if (waterEvacuationPosition == "A1" && waterEvacuationChacker == true) {
            v3d.puzzles.procedures.pwaterEvacuationA1();
        }
        if (waterEvacuationPosition == "A2" && waterEvacuationChacker == true) {
            v3d.puzzles.procedures.pwaterEvacuationA2();
        }
        if (waterEvacuationPosition == "A3" && waterEvacuationChacker == true) {
            v3d.puzzles.procedures.pwaterEvacuationA3();
        }
        if (waterEvacuationPosition == "A4" && waterEvacuationChacker == true) {
            v3d.puzzles.procedures.pwaterEvacuationA4();
        }
        if (waterEvacuationPosition == "B1" && waterEvacuationChacker == true) {
            v3d.puzzles.procedures.pwaterEvacuationB1();
        }
        if (waterEvacuationPosition == "B2" && waterEvacuationChacker == true) {
            v3d.puzzles.procedures.pwaterEvacuationB2();
        }
        if (waterEvacuationPosition == "B3" && waterEvacuationChacker == true) {
            v3d.puzzles.procedures.pwaterEvacuationB3();
        }
        if (waterEvacuationPosition == "B4" && waterEvacuationChacker == true) {
            v3d.puzzles.procedures.pwaterEvacuationB4();
        }
    }
}

/**
 * Builder - getting proper POWER SUPPLY value
 */

function powerSuppltyBuider() {
    if (
        document.getElementById("power_supply_position_0") != undefined ||
        globalPowerSupplyChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.has("power_supply") &&
        urlParams.get("power_supply") != undefined
    ) {
        globalInputPowerSupply = urlParams.get("power_supply");
    }
    let powerSupplyPosition = globalInputPowerSupply.split("")[5];

    if (powerSupplyPosition == "1") {
        v3d.puzzles.procedures.pPowerSupplyP1();
    }
    if (powerSupplyPosition == "2") {
        v3d.puzzles.procedures.pPowerSupplyP2();
    }
    if (powerSupplyPosition == "3") {
        v3d.puzzles.procedures.pPowerSupplyP3();
    }
    if (powerSupplyPosition == "4") {
        v3d.puzzles.procedures.pPowerSupplyP4();
    }
}

/**
 * Builder - getting proper MOTOR POSITION value
 */
function mororPositionBuilder() {
    if (
        document.getElementById("motor_position") != undefined ||
        globaltMotorChanges == true
    ) {
        //no need for any changes because values are alreay updated
    } else if (
        urlParams.has("motor_position") &&
        urlParams.get("motor_position") != undefined
    ) {
        globalInputMotor = urlParams.get("motor_position");
    }

    let motorPosition = globalInputMotor.split("")[4];

    if (motorPosition == "B") {
        v3d.puzzles.procedures.pMotorPositionP1_P2();
    }
    if (motorPosition == "A") {
        v3d.puzzles.procedures.pMotorPositionP3_P4();
    }
}

/**
 * Append mesures to the pergola - cote
 */
function submitMesures() {
    v3d.puzzles.procedures.pMesuresLength(globalInputLenghtMesureValue + " mm");
    v3d.puzzles.procedures.pMesuresWidth(globalInputWidthMesureValue + " mm");
    v3d.puzzles.procedures.pMesureHeight(globalInputHeightMesureValue + " mm");
}

/**
 *Closing the roof
 */
function closeRoof() {
    if (lamela_rotation >= -9) {
        lamela_rotation -= 1;
        v3d.puzzles.procedures.pCloseRoof();
    }
}

/**
 *Opening the roof
 */
function openRoof() {
    if (lamela_rotation <= 9) {
        lamela_rotation += 1;
        v3d.puzzles.procedures.pOpenRoof();
    }
}

/**
 *Opening the roof with radio
 *means it calcualtes how much time it has to rotate roof, by 5.
 */
function SubmitAngleOfRoof() {
    var angle = document.getElementById("angle").value;

    if (initialAngleValue != angle) {
        var difference = angle - initialAngleValue;

        initialAngleValue = angle;

        for (let i = 0; i < Math.abs(difference); i++) {
            if (difference < 0) {
                setTimeout(() => {
                    // make the move looks like the animation
                    closeRoof();
                }, 100 * i);
            } else {
                setTimeout(() => {
                    // make the move looks like the animation
                    openRoof();
                }, 100 * i);
            }
        }
    }
}

/**
 *Lights
 */
function turnLightsOn() {
    v3d.puzzles.procedures.pTurnOnLights();
}

function turnLightsOff() {
    v3d.puzzles.procedures.pTurnOffLights();
}

/**
 *Animations
 */

//Daily csun move simulation
function animationSunMove() {
    v3d.puzzles.procedures.pAnimationSunMove();
}

function animateCameraMove() {
    v3d.puzzles.procedures.pAnimationSunMove();
}

//Change view
function setActiveCamera() {
    v3d.puzzles.procedures.pChangeActiveCamera();
}

//moving sun for part of the circe
function moveSunForBit() {
    if (sunMoveForBitCounter > 4) {
        stopAnimations;
        animationSunMove();
        sunMoveForBitCounter = 0;
    }
    if (sunMoveForBitCounter == 0) {
        animationSunMove();
    }
    sunMoveForBitCounter++;

    pauseAnimations();
    resumeAnimations();
    setTimeout(() => {
        pauseAnimations();
    }, 2000);
}

//Screen Shot
function screenShot() {
    v3d.puzzles.procedures.pScreenshot();
}

//triple screenshot when model generation is done
function autoScreenshot() {}

/**
 * Manipulate with the animatons.
 */
function stopAnimations() {
    v3d.puzzles.procedures.pStopAnimations();
}
function pauseAnimations() {
    v3d.puzzles.procedures.pPauseAnimations();
}
function resumeAnimations() {
    v3d.puzzles.procedures.pResumeAnimations();
}
function setBackgroundImage() {
    let input = document.createElement("input");
    input.type = "file";
    input.onchange = (_) => {
        // you can use this method to get file and perform respective operations
        let image = input.files;
        console.log(image);
        let imageName = getBase64(image[0]).then((val) => {
            console.log(val);
            var imageNameURL = "url(" + val + ")";
            v3d.puzzles.procedures.pSetBackgorundImage(imageNameURL);
        });
    };
    input.click();
}

function getBase64(file) {
    return new Promise((resolve) => {
        var reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = function () {
            console.log(reader.result);
            resolve(reader.result);
        };
        reader.onerror = function (error) {
            console.log("Error: ", error);
        };
    });
}

function generateNumbers(startingPoint, step) {
    let n = startingPoint;
    let list = [];
    list[1] = n;

    for (let i = 0; i < 57 - 1; i++) {
        n = n + step;
        list.push(n);
        console.log("n = ", n);
    }
}

/**
 * Function which reconstruct model from the input fields paramehters
 */
function reconstruct() {
    document.getElementById("v3d-container").innerHTML = "";
    doSomething();
}

/**
 * Submit new values from html
 */

// Submit new  LENGTH value from input field
function submitNewLengthValuesFromFields() {
    if (document.getElementById("length") != undefined) {
        globalInputLength = document.getElementById("length").value;
        globalInputLenghtMesureValue = document.getElementById("length").value;
        if (
            globalInputLength < lengths[0] ||
            globalInputLenghtMesureValue < lengths[0]
        ) {
            globalInputLength = lengths[0];
            globalInputLenghtMesureValue = lengths[0];
        }
        if (
            globalInputLength > lengths[lengths.length - 1] ||
            globalInputLenghtMesureValue > lengths[lengths.length - 1]
        ) {
            globalInputLength = lengths[lengths.length - 1];
            globalInputLenghtMesureValue = lengths[lengths.length - 1];
        }
        globalLengthChanges = true;
    }
}

// Submit new  WIDTH value from input field
function submitNewWidthValuesFromFields() {
    if (document.getElementById("width") != undefined) {
        globalInputWidth = document.getElementById("width").value;
        globalInputWidthMesureValue = document.getElementById("width").value;
        if (
            globalInputWidth < widths[0] ||
            globalInputWidthMesureValue < widths[0]
        ) {
            globalInputWidth = widths[0];
            globalInputWidthMesureValue = widths[0];
        }
        globalWidthChanges = true;
    }
}

// Submit new  HEIGHT value from input field
function submitNewHeightValuesFromFields() {
    if (document.getElementById("height") != undefined) {
        globalInputHeight = document.getElementById("height").value;
        globalInputHeightMesureValue = document.getElementById("height").value;
        globalHeightChanges = true;
    }
}

// Submit new  STRUCTURE COLOR value from input field
function submitNewStructureColorValuesFromFields(value) {
    value;

    if (value != undefined) {
        globalInputStructureColor = value;
        globalStructureColorChanges = true;
    }
}

// Submit new  BLADE COLOR value from input field
function submitNewBladesColorValuesFromFields(value) {
    if (value != undefined) {
        globalInputBladesColor = value;
        globalBladesColorChanges = true;
    }
}
// other values submit themselve from theirs function on change
// like (wall moutning, glass... )
//

function updateInputFields() {
    //sort poles
    submitLengthHTML();
    submitWidthHTML();
    submitHeightHTML();
    submitMesures();

    submitStructureColorHTML();
    submitBladesColorHTML();

    submitStandardPolesHTML();
    submitAdditionalPolesHTML();
    submitWallMountingHTML();
    submitGlassHTML();
    submitZipHTML();
    submitSlidingHTML();
    submitWaterEvacuationHTML();
    submitPowerSupplyHTML();
    submitMotorHTML();

    // prepare material design on inputs
    for (const el of document.querySelectorAll(".mdc-text-field")) {
        const MDCTextField = mdc.textField.MDCTextField;
        const textFieldControl = new MDCTextField(el);
    }
}

/**
 *      HTML
 *      HTML
 *       HTML
 * Function for update all input fileds on real values of model from INPUT FIELDS
 */

/**
 * Reading and submiting LENGTH from input fields
 * Reading and submiting LENGTH from input fields
 * Reading and submiting LENGTH from input fields
 */
function submitLengthHTML() {
    const newHtml = `
        <label
            class="mdc-text-field mdc-text-field--outlined w-100"
        >
            <span class="mdc-notched-outline">
                <span
                    class="mdc-notched-outline__leading"
                ></span>
                <span class="mdc-notched-outline__notch">
                    <span
                        class="mdc-floating-label"
                        id="my-label-id"
                    >
                        Length (mm)
                    </span>
                </span>
                <span
                    class="mdc-notched-outline__trailing"
                ></span>
            </span>
            <input
                type="number"
                class="mdc-text-field__input"
                aria-labelledby="my-label-id"
                id="length"
                name="length"
                value="${globalInputLength}"
                min="1059"
                max="10000"
                onchange="submitNewLengthValuesFromFields()"
            />
        </label>
    `;

    document.getElementById("lengthContainer").innerHTML = newHtml;
}

/**
 * Reading and submiting wIDTH from input fields
 * Reading and submiting wIDTH from input fields
 * Reading and submiting wIDTH from input fields
 */
function submitWidthHTML() {
    const newHtml = `
        <label
            class="mdc-text-field mdc-text-field--outlined w-100"
        >
            <span class="mdc-notched-outline">
                <span
                    class="mdc-notched-outline__leading"
                ></span>
                <span class="mdc-notched-outline__notch">
                    <span
                        class="mdc-floating-label"
                        id="my-label-id"
                    >
                        Width (mm)
                    </span>
                </span>
                <span
                    class="mdc-notched-outline__trailing"
                ></span>
            </span>
            <input
                type="number"
                class="mdc-text-field__input"
                aria-labelledby="my-label-id"
                id="width"
                name="width"
                value="${globalInputWidth}"
                min="1500"
                max="6000"
                onchange="submitNewWidthValuesFromFields()"
            />
        </label>
    `;
    document.getElementById("widthContainer").innerHTML = newHtml;
}

/**
 * Reading and submiting HEIGHT from input fields
 * Reading and submiting HEIGHT from input fields
 * Reading and submiting HEIGHT from input fields
 */
function submitHeightHTML() {
    const newHtml = `
        <label
            class="mdc-text-field mdc-text-field--outlined w-100"
        >
            <span class="mdc-notched-outline">
                <span
                    class="mdc-notched-outline__leading"
                ></span>
                <span class="mdc-notched-outline__notch">
                    <span
                        class="mdc-floating-label"
                        id="my-label-id"
                    >
                        Height (mm)
                    </span>
                </span>
                <span
                    class="mdc-notched-outline__trailing"
                ></span>
            </span>
            <input
                type="number"
                class="mdc-text-field__input"
                aria-labelledby="my-label-id"
                id="height"
                name="height"
                value="${globalInputHeight}"
                min="200"
                max="4000"
                onchange="submitNewHeightValuesFromFields()"
            />
        </label>
    `;

    document.getElementById("heightContainer").innerHTML = newHtml;
}

/**
 * Reading and submiting STRUCTURE COLOR from input fields
 * Reading and submiting STRUCTURE COLOR from input fields
 * Reading and submiting STRUCTURE COLOR from input fields
 */
function submitStructureColorHTML() {
    const { newHtml, builder } = createColorPickerMenu(
        globalInputStructureColor
    );

    document.getElementById("structureColorContainer").innerHTML = newHtml;

    builder("structureColorContainer", submitNewStructureColorValuesFromFields);
}

/**
 * Reading and submiting BLADES COLOR from input fields
 * Reading and submiting BLADES COLOR from input fields
 * Reading and submiting BLADES COLOR from input fields
 */
function submitBladesColorHTML() {
    const { newHtml, builder } = createColorPickerMenu(globalInputBladesColor);

    document.getElementById("bladesColorContainer").innerHTML = newHtml;

    builder("bladesColorContainer", submitNewBladesColorValuesFromFields);
}

/**
 * Keeps the evidence if we are already listening for
 * material design inputs changes.
 */
const listeners = {};

/**
 * Select input field for standard poles (p1, p2, p3, p4)
 */
function selectInputFieldForPoles(id, onInputChange) {
    let newHtml = "";

    newHtml += `
        <div class="w-100 mdc-select mdc-select--outlined">
            <div
                class="mdc-select__anchor"
                aria-labelledby="outlined-select-label"
            >
                <span class="mdc-notched-outline">
                    <span
                        class="mdc-notched-outline__leading"
                    ></span>
                    <span class="mdc-notched-outline__notch">
                        <span
                            id="outlined-select-label"
                            class="mdc-floating-label"
                        >
                            Select position
                        </span>
                    </span>
                    <span
                        class="mdc-notched-outline__trailing"
                    ></span>
                </span>
                <span
                    class="mdc-select__selected-text-container"
                >
                    <span
                        id="demo-selected-text"
                        class="mdc-select__selected-text"
                    ></span>
                </span>
                <span class="mdc-select__dropdown-icon">
                    <svg
                        class="
                            mdc-select__dropdown-icon-graphic
                        "
                        viewBox="7 10 10 5"
                        focusable="false"
                    >
                        <polygon
                            class="
                                mdc-select__dropdown-icon-inactive
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 10 12 15 17 10"
                        ></polygon>
                        <polygon
                            class="
                                mdc-select__dropdown-icon-active
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 15 12 10 17 15"
                        ></polygon>
                    </svg>
                </span>
            </div>

            <div
                class="
                    mdc-select__menu
                    mdc-menu
                    mdc-menu-surface
                    mdc-menu-surface--fullwidth
                "
            >
                <ul
                    class="mdc-list"
                    role="listbox"
                    aria-label="Food picker listbox"
                >
                    
    `;

    for (const position of standardPolePositions) {
        newHtml += `
                        <li
                            class="mdc-list-item"
                            aria-selected="false"
                            data-value="${position}"
                            role="option"
                        >
                            <span
                                class="mdc-list-item__ripple"
                            ></span>
                            <span class="mdc-list-item__text">
                                ${position}
                            </span>
                        </li>
        `;
    }

    newHtml += `
                </ul>
            </div>
        </div>
    `;

    // set new body
    document.getElementById(id + "Selector").innerHTML = newHtml;

    // set listener for material select changes
    const item = document.getElementById(id + "Selector");

    const MDCSelect = mdc.select.MDCSelect;
    const selectControl = new MDCSelect(item);

    // do not add one more listener for same field if it already exists
    if (listeners[id] == undefined) {
        listeners[id] = true;

        // listen for any changes and call on input change function with
        // new value
        selectControl.listen("MDCSelect:change", (event) => {
            onInputChange(event.detail.value);
        });
    }
}

/**
 * Creates color picker. Returns object with new html and builder
 * which is needed for preparing provided select.
 * @param {*} selectedValue - value that is selected from
 * colors lists (ral color id)
 * @param {*} shouldCheckIfAlreadyListening - if false then it
 * will not check if we already set listener on
 * @returns {newHtml: string, builder: fun(id: string, onInputChange: fun(value:any))}
 */
function createColorPickerMenu(
    selectedValue,
    shouldCheckIfAlreadyListening = true
) {
    let newHtml = "";

    newHtml += `
        <div class="w-100 mdc-select mdc-select--outlined">
            <div
                class="mdc-select__anchor"
                aria-labelledby="outlined-select-label"
            >
                <span class="mdc-notched-outline">
                    <span
                        class="mdc-notched-outline__leading"
                    ></span>
                    <span class="mdc-notched-outline__notch">
                        <span
                            id="outlined-select-label"
                            class="mdc-floating-label"
                        >
                            Select color
                        </span>
                    </span>
                    <span
                        class="mdc-notched-outline__trailing"
                    ></span>
                </span>
                <span
                    class="mdc-select__selected-text-container"
                >
                    <span
                        id="demo-selected-text"
                        class="mdc-select__selected-text"
                    ></span>
                </span>
                <span class="mdc-select__dropdown-icon">
                    <svg
                        class="
                            mdc-select__dropdown-icon-graphic
                        "
                        viewBox="7 10 10 5"
                        focusable="false"
                    >
                        <polygon
                            class="
                                mdc-select__dropdown-icon-inactive
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 10 12 15 17 10"
                        ></polygon>
                        <polygon
                            class="
                                mdc-select__dropdown-icon-active
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 15 12 10 17 15"
                        ></polygon>
                    </svg>
                </span>
            </div>

            <div
                class="
                    mdc-select__menu
                    mdc-menu
                    mdc-menu-surface
                    mdc-menu-surface--fullwidth
                "
            >
                <ul
                    class="mdc-list"
                    role="listbox"
                    aria-label="Food picker listbox"
                >
                    
    `;
    const keys = Object.keys(RALColors);
    for (const key of keys) {
        newHtml += `
                        <li
                            class="mdc-list-item ${
                                selectedValue == key
                                    ? "mdc-list-item--selected"
                                    : ""
                            }" 
                            ${
                                selectedValue == key
                                    ? 'aria-selected="true"'
                                    : ""
                            }
                            aria-selected="false"
                            data-value="${key}"
                            role="option"
                        >
                            <span
                                class="mdc-list-item__ripple"
                            ></span>
                            <span class="mdc-list-item__text" style="padding-top:10px">
                                ${key} 
                                <br>
                                <small>${RALColors[key].name}</small>
                            </span>
                        </li>
        `;
    }

    newHtml += `
                </ul>
            </div>
        </div>
    `;

    return {
        newHtml,
        builder: function (id, onInputChange) {
            document.getElementById(id).innerHTML = newHtml;

            // set listener for material select changes
            const item = document.getElementById(id);

            const MDCSelect = mdc.select.MDCSelect;
            const selectControl = new MDCSelect(item);

            // do not add one more listener for same field if it already exists
            if (
                shouldCheckIfAlreadyListening == false ||
                listeners[id] == undefined
            ) {
                listeners[id] = true;

                // listen for any changes and call on input change function with
                // new value
                selectControl.listen("MDCSelect:change", (event) => {
                    onInputChange(event.detail.value);
                });
            }
        },
    };
}

/**
 * Universal input field (p1-p2, p1-p3, p2-p3... ).
 * @param {*} id
 */
function createSelectInputForPergolaSides(id, onInputChange) {
    let newHtml = "";

    newHtml += `
        <div class="w-100 mdc-select mdc-select--outlined">
            <div
                class="mdc-select__anchor"
                aria-labelledby="outlined-select-label"
            >
                <span class="mdc-notched-outline">
                    <span
                        class="mdc-notched-outline__leading"
                    ></span>
                    <span class="mdc-notched-outline__notch">
                        <span
                            id="outlined-select-label"
                            class="mdc-floating-label"
                        >
                            Select position
                        </span>
                    </span>
                    <span
                        class="mdc-notched-outline__trailing"
                    ></span>
                </span>
                <span
                    class="mdc-select__selected-text-container"
                >
                    <span
                        id="demo-selected-text"
                        class="mdc-select__selected-text"
                    ></span>
                </span>
                <span class="mdc-select__dropdown-icon">
                    <svg
                        class="
                            mdc-select__dropdown-icon-graphic
                        "
                        viewBox="7 10 10 5"
                        focusable="false"
                    >
                        <polygon
                            class="
                                mdc-select__dropdown-icon-inactive
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 10 12 15 17 10"
                        ></polygon>
                        <polygon
                            class="
                                mdc-select__dropdown-icon-active
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 15 12 10 17 15"
                        ></polygon>
                    </svg>
                </span>
            </div>

            <div
                class="
                    mdc-select__menu
                    mdc-menu
                    mdc-menu-surface
                    mdc-menu-surface--fullwidth
                "
            >
                <ul
                    class="mdc-list"
                    role="listbox"
                    aria-label="Food picker listbox"
                >
                    
    `;

    for (const side of sides) {
        newHtml += `
                        <li
                            class="mdc-list-item"
                            aria-selected="false"
                            data-value="${side}"
                            role="option"
                        >
                            <span
                                class="mdc-list-item__ripple"
                            ></span>
                            <span class="mdc-list-item__text">
                                ${side}
                            </span>
                        </li>
        `;
    }

    newHtml += `
                </ul>
            </div>
        </div>
    `;

    // set new body
    document.getElementById(id).innerHTML = newHtml;

    // set listener for material select changes
    const item = document.getElementById(id);

    const MDCSelect = mdc.select.MDCSelect;
    const selectControl = new MDCSelect(item);

    // do not add one more listener for same field if it already exists
    if (listeners[id] == undefined) {
        listeners[id] = true;

        // listen for any changes and call on input change function with
        // new value
        selectControl.listen("MDCSelect:change", (event) => {
            onInputChange(event.detail.value);
        });
    }
}

/**
 * Reading and submiting STANDARD POLES from input fields
 * Reading and submiting STANDARD POLES from input fields
 * Reading and submiting STANDARD POLES from input fields
 */

function submitStandardPolesHTML() {
    var newHTML = "<div>";
    selectInputFieldForPoles("standardPoles", onPositionSelect_standardPoles);

    for (let index = 0; index < globalInputPolesArray.length; index++) {
        newHTML += `
            <div class="my-card mdc-card mdc-card--outlined d-inline-block">
                <div
                    class="mdc-card__content my-card-content"
                    style="padding-left: 10px; padding-right: 10px"
                >
                    <span id = "polePosition_${index}" >  
                        ${globalInputPolesArray[index].position}
                    </span> 
                    Pole
                    
                    <button
                        class="
                            mdc-icon-button
                            material-icons
                            close-button
                        "
                        id="${index}"
                        onclick="removeValueInglobalInputPolesArray(${index})"
                    >
                        <div class="mdc-icon-button__ripple"></div>
                        close
                    </button>

                    <!-- INPUT -->
                    <label
                        class="
                            mdc-text-field mdc-text-field--outlined
                            w-100
                        "
                        style="margin-top: 20px"
                    >
                        <span class="mdc-notched-outline">
                            <span
                                class="mdc-notched-outline__leading"
                            ></span>
                            <span
                                class="mdc-notched-outline__notch"
                            >
                                <span
                                    class="mdc-floating-label"
                                    id="my-label-id"
                                >
                                    Height (mm)
                                </span>
                            </span>
                            <span
                                class="
                                    mdc-notched-outline__trailing
                                "
                            ></span>
                        </span>
                        <input
                            type="number"
                            class="mdc-text-field__input"
                            aria-labelledby="my-label-id"
                            id = "standard_pole_height_${index}" 
                            name = "standard_pole_height_${index}" 
                            value = "${globalInputPolesArray[index].height}"
                            onchange = "changeHeightOfStandardPole(${index})" 
                        />
                    </label>
                </div>
            </div>
        `;
    }

    newHTML += "</div>";

    document.getElementById("standardPolesArrayContainer").innerHTML = newHTML;
}

// change height
function changeHeightOfStandardPole(index) {
    globalInputPolesArray[index].height = parseInt(
        document.getElementById("standard_pole_height_" + index).value
    );
    globalPolesArrayChanges = true;
}

// changes / addign new value
function onPositionSelect_standardPoles(value) {
    if (value == undefined) {
        return;
    }

    const exists = globalInputPolesArray.find((item) => item.position == value);

    if (exists == undefined) {
        // add element to list
        globalInputPolesArray.push({
            position: value,
            height: 2400,
        });
    }

    // submitStandradPolesHTML();
    globalPolesArrayChanges = true;
    updateInputFields();
}

//remove value from globalInputPolesArray
function removeValueInglobalInputPolesArray(index) {
    deleteTrashWhenDeleteStandardPole(
        index,
        globalInputWallMountingArray,
        "wall"
    );
    deleteTrashWhenDeleteStandardPole(index, globalInputGlassArray, "glass");
    deleteTrashWhenDeleteStandardPole(index, globalInputZipArray, "zip");
    globalInputPolesArray.splice(index, 1);

    // submitStandradPolesHTML();
    globalPolesArrayChanges = true;
    updateInputFields();
}

function deleteTrashWhenDeleteStandardPole(
    indexArgument,
    toBeDeletedArrayArgument,
    arrayRecogniton
) {
    let indexPosition = globalInputPolesArray[indexArgument].position;
    let positionsToDelete = [];
    let counter = 0;

    for (let index = 0; index < toBeDeletedArrayArgument.length; index++) {
        let wordOnPosition =
            toBeDeletedArrayArgument[index].position.split("-");
        if (wordOnPosition[0] == indexPosition) {
            // positionsToDelete.push(index);
            toBeDeletedArrayArgument.splice(index, 1);
        } else if (wordOnPosition[1] == indexPosition) {
            // positionsToDelete.push(index);
            toBeDeletedArrayArgument.splice(index, 1);
        }
    }

    // for (let i = 0; i < positionsToDelete.length; i++) {
    //     let currentPositinToDelete = positionsToDelete[i];
    //     toBeDeletedArrayArgument.splice(currentPositinToDelete, 1);

    // }
    if (arrayRecogniton == "wall") {
        globalInputWallMountingArray = toBeDeletedArrayArgument;
    } else if (arrayRecogniton == "glass") {
        globalInputGlassArray = toBeDeletedArrayArgument;
    } else if (arrayRecogniton == "zip") {
        globalInputZipArray = toBeDeletedArrayArgument;
    }
}

/**
 * Reading and submiting ADDITIONAL POLES from input field
 * Reading and submiting ADDITIONAL POLES from input field
 * Reading and submiting ADDITIONAL POLES from input field
 */

//read and display value from globalInputAdditionalPolesArray
function submitAdditionalPolesHTML() {
    var newHTML = "<div>";
    createSelectInputForPergolaSides(
        "additionalPolesSelector",
        onPositionSelect_additionalPolesSelector
    );

    for (
        let index = 0;
        index < globalInputAdditionalPolesArray.length;
        index++
    ) {
        newHTML += `
            <div class="my-card mdc-card mdc-card--outlined d-inline-block">
                <div
                    class="mdc-card__content my-card-content"
                    style="padding-left: 10px; padding-right: 10px"
                >
                    <span id = "additionalPolePosition_${index}" >  
                        ${globalInputAdditionalPolesArray[index].position}
                    </span> 
                    Additional pole
                    
                    <button
                        class="
                            mdc-icon-button
                            material-icons
                            close-button
                        "
                        id="${index}"
                        onclick="removeValueInglobalInputAdditionalPolesArray(${index})"
                    >
                        <div class="mdc-icon-button__ripple"></div>
                        close
                    </button>

                    <!-- INPUT -->
                    <label
                        class="
                            mdc-text-field mdc-text-field--outlined
                            w-100
                        "
                        style="margin-top: 20px"
                    >
                        <span class="mdc-notched-outline">
                            <span
                                class="mdc-notched-outline__leading"
                            ></span>
                            <span
                                class="mdc-notched-outline__notch"
                            >
                                <span
                                    class="mdc-floating-label"
                                    id="my-label-id"
                                >
                                    Height (mm)
                                </span>
                            </span>
                            <span
                                class="
                                    mdc-notched-outline__trailing
                                "
                            ></span>
                        </span>
                        <input
                            type="number"
                            class="mdc-text-field__input"
                            aria-labelledby="my-label-id"
                            id = "additional_pole_height_${index}" 
                            name = "additional_pole_height_${index}" 
                            value = "${globalInputAdditionalPolesArray[index].height}"
                            onchange = "changeHeightOfAdditionalPole(${index})" 
                        />
                    </label>

                    <!-- INPUT -->
                    <label
                        class="
                            mdc-text-field mdc-text-field--outlined
                            w-100
                        "
                        style="margin-top: 20px"
                    >
                        <span class="mdc-notched-outline">
                            <span
                                class="mdc-notched-outline__leading"
                            ></span>
                            <span
                                class="mdc-notched-outline__notch"
                            >
                                <span
                                    class="mdc-floating-label"
                                    id="my-label-id"
                                >
                                    Distance to left (mm)
                                </span>
                            </span>
                            <span
                                class="
                                    mdc-notched-outline__trailing
                                "
                            ></span>
                        </span>
                        <input
                            type="number"
                            class="mdc-text-field__input"
                            aria-labelledby="my-label-id"
                            id = "additional_pole_distance_${index}" 
                            name = "additional_pole_distance_${index}" 
                            value = "${globalInputAdditionalPolesArray[index].distance_to_left}"
                            onchange = "changeDistanceOfAdditionalPole(${index})" 
                        />
                    </label>
                </div>
            </div>
        `;
    }

    newHTML += "</div>";

    document.getElementById("additionalPolesArrayContainer").innerHTML =
        newHTML;
}

//change distance of additional pole
function changeDistanceOfAdditionalPole(index) {
    globalInputAdditionalPolesArray[index].distance_to_left = parseInt(
        document.getElementById("additional_pole_distance_" + index).value
    );
    globalAdditionalPolesArrayChanges = true;
}

//change height of additional pole
function changeHeightOfAdditionalPole(index) {
    globalInputAdditionalPolesArray[index].height = parseInt(
        document.getElementById("additional_pole_height_" + index).value
    );
    globalAdditionalPolesArrayChanges = true;
}

// adding new value
function onPositionSelect_additionalPolesSelector(value) {
    // if (value == undefined) {
    //     return;
    // }

    // const exists = globalInputAdditionalPolesArray.find(
    //     (item) => item.position == value
    // );

    // if (exists == undefined) {
    // add element to list
    globalInputAdditionalPolesArray.push({
        position: value,
        distance_to_left: 500,
        height: globalInputHeight,
    });
    // }

    globalAdditionalPolesArrayChanges = true;
    updateInputFields();
}

//remove value from globalInputAdditionalPolesArray
function removeValueInglobalInputAdditionalPolesArray(index) {
    globalInputAdditionalPolesArray.splice(index, 1);

    deleteTrashWhenDeleteAdditionalPole(
        index,
        globalInputWallMountingArray,
        "wall"
    );
    deleteTrashWhenDeleteAdditionalPole(index, globalInputGlassArray, "glass");
    deleteTrashWhenDeleteAdditionalPole(index, globalInputZipArray, "zip");
    deleteTrashWhenDeleteAdditionalPole(index, globalInputSlideArray, "slide");

    globalAdditionalPolesArrayChanges = true;
    updateInputFields();
}

function deleteTrashWhenDeleteAdditionalPole(
    indexArgument,
    toBeDeletedArrayArgument,
    arrayRecogniton
) {
    let letterPosition;
    let positionsToDelete = [];
    let counter = 0;

    for (let index = 0; index < toBeDeletedArrayArgument.length; index++) {
        letterPosition = toBeDeletedArrayArgument[index].position.split("");

        if (
            letterPosition[0] == "#" &&
            letterPosition[1] == indexArgument + 1
        ) {
            // toBeDeletedArrayArgument.splice(index, 1);
            positionsToDelete.push(index);
            positionsToDelete;
        }
        if (
            letterPosition[3] == "#" &&
            letterPosition[4] == indexArgument + 1
        ) {
            // toBeDeletedArrayArgument.splice(index, 1);
            positionsToDelete.push(index);
            positionsToDelete;
        }
        positionsToDelete;
    }

    for (let i = 0; i < positionsToDelete.length; i++) {
        let currentPositinToDelete = positionsToDelete[i];

        currentPositinToDelete = currentPositinToDelete - counter;

        toBeDeletedArrayArgument.splice(currentPositinToDelete, 1);

        counter++;
    }

    for (
        let i = positionsToDelete[0];
        i < toBeDeletedArrayArgument.length;
        i++
    ) {
        // for __ - #_

        let wordPosition = toBeDeletedArrayArgument[i].position.split("-");
        let leterOnPosition = toBeDeletedArrayArgument[i].position.split("");

        let numberOnFirstPosition =
            toBeDeletedArrayArgument[i].position.split("")[1];
        let nubmerOnSecondPosition = parseInt(
            toBeDeletedArrayArgument[i].position.split("")[4]
        );

        // case: #_ - __
        if (leterOnPosition[0] == "#") {
            let firstCaseNewValue = "";
            firstCaseNewValue += leterOnPosition[0];
            let firstCaseNewValue2 = "";
            firstCaseNewValue2 += wordPosition[0];
            let toDelete1 = firstCaseNewValue.split("")[0];
            firstCaseNewValue2 = firstCaseNewValue2.replace(toDelete1, "");
            firstCaseNewValue += firstCaseNewValue2 - 1;
            firstCaseNewValue += "-";
            firstCaseNewValue += wordPosition[1];

            toBeDeletedArrayArgument[i].position = firstCaseNewValue;
        }

        // have to update valuse because they might be changed in previous step
        wordPosition = toBeDeletedArrayArgument[i].position.split("-");
        leterOnPosition = toBeDeletedArrayArgument[i].position.split("");
        numberOnFirstPosition = parseInt(
            toBeDeletedArrayArgument[i].position.split("")[1]
        );
        nubmerOnSecondPosition = parseInt(
            toBeDeletedArrayArgument[i].position.split("")[4]
        );

        // case: __ - #_
        if (leterOnPosition[3] == "#") {
            let secondCaseNewValue = "";
            secondCaseNewValue += wordPosition[0];
            if (i < 10) {
                secondCaseNewValue += leterOnPosition[2];
            } else {
                secondCaseNewValue += leterOnPosition[3];
            }
            let secondCaseNewValue2 = "";
            secondCaseNewValue2 += wordPosition[1];
            let toDelete2 = secondCaseNewValue2.split("")[0];
            secondCaseNewValue2 = secondCaseNewValue2.replace(toDelete2, "");
            let newValue2 = "";
            newValue2 += wordPosition[0];
            newValue2 += leterOnPosition[2];
            newValue2 += leterOnPosition[3];
            newValue2 += leterOnPosition[4] - 1;
            toBeDeletedArrayArgument[i].position = newValue2;
        }
    }

    if (arrayRecogniton == "wall") {
        globalInputWallMountingArray = toBeDeletedArrayArgument;
    } else if (arrayRecogniton == "glass") {
        globalInputGlassArray = toBeDeletedArrayArgument;
    } else if (arrayRecogniton == "zip") {
        globalInputZipArray = toBeDeletedArrayArgument;
    } else if (arrayRecogniton == "slide") {
        globalInputSlideArray = toBeDeletedArrayArgument;
    }

    updateInputFields();
}

/**
 *  Univerzal input field for wall wounting, glass, zip
 *               all combinations ( OPTGROUP:p1-p2: p1-#1, p1-#2 .... ,
 *                                  OPTGROUP:p1-p2 #1-p2..., p1-p3, p2-p3... )
 */
function inputFieldOptGroup(id, onInputChange) {
    let newHtml = "";

    newHtml += `
        <div class="w-100 mdc-select mdc-select--outlined">
            <div
                class="mdc-select__anchor"
                aria-labelledby="outlined-select-label"
            >
                <span class="mdc-notched-outline">
                    <span
                        class="mdc-notched-outline__leading"
                    ></span>
                    <span class="mdc-notched-outline__notch">
                        <span
                            id="outlined-select-label"
                            class="mdc-floating-label"
                        >
                            Select position
                        </span>
                    </span>
                    <span
                        class="mdc-notched-outline__trailing"
                    ></span>
                </span>
                <span
                    class="mdc-select__selected-text-container"
                >
                    <span
                        id="demo-selected-text"
                        class="mdc-select__selected-text"
                    ></span>
                </span>
                <span class="mdc-select__dropdown-icon">
                    <svg
                        class="
                            mdc-select__dropdown-icon-graphic
                        "
                        viewBox="7 10 10 5"
                        focusable="false"
                    >
                        <polygon
                            class="
                                mdc-select__dropdown-icon-inactive
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 10 12 15 17 10"
                        ></polygon>
                        <polygon
                            class="
                                mdc-select__dropdown-icon-active
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 15 12 10 17 15"
                        ></polygon>
                    </svg>
                </span>
            </div>

            <div
                class="
                    mdc-select__menu
                    mdc-menu
                    mdc-menu-surface
                    mdc-menu-surface--fullwidth
                "
            >
                <ul
                    class="mdc-list"
                    role="listbox"
                    aria-label="Food picker listbox"
                >
                    
    `;

    for (const side of sides) {
        if (side == "") {
            continue;
        }

        newHtml += `
                    <li style="margin-bottom:10px; padding-left:5px;">
                        <i>Side ${side}:</i>
                        <ul>
        `;

        generateAllPossiblePositions(side);
        allPossibleCombinationsForOneSide(allPossiblePolePositions);

        for (const value of allPossibleCombinations) {
            newHtml += `
                            <li
                                class="mdc-list-item"
                                aria-selected="false"
                                data-value="${value}"
                                role="option"
                                style="margin-bottom:4px"
                            >
                                <span
                                    class="mdc-list-item__ripple"
                                ></span>
                                <span class="mdc-list-item__text" style="font-weight: bold;">
                                    ${value}
                                </span>
                            </li>
            `;
        }

        newHtml += `
                        </ul>
                    </li>
        `;
    }

    newHtml += `
                </ul>
            </div>
        </div>
    `;

    // set new body
    document.getElementById(id).innerHTML = newHtml;

    // set listener for material select changes
    const item = document.getElementById(id);

    const MDCSelect = mdc.select.MDCSelect;
    const selectControl = new MDCSelect(item);

    // do not add one more listener for same field if it already exists
    if (listeners[id] == undefined) {
        listeners[id] = true;

        // listen for any changes and call on input change function with
        // new value
        selectControl.listen("MDCSelect:change", (event) => {
            onInputChange(event.detail.value);
        });
    }
}

/**
 * generate all possible positions for mouitnig, glass, zip...
 *              input is one side, example "P1-P2", output for that side (#1. #2...)
 */
function generateAllPossiblePositions(selectedSide = "") {
    let fromPoleSide = selectedSide.split("-")[0];
    let toPoleSide = selectedSide.split("-")[1];

    allPossiblePolePositions = [];

    allPossiblePolePositions.push(fromPoleSide);

    for (let i = 0; i < globalInputAdditionalPolesArray.length; i++) {
        let fromAddtionalPole =
            globalInputAdditionalPolesArray[i].position.split("-")[0];
        let toAdditionalPole =
            globalInputAdditionalPolesArray[i].position.split("-")[1];

        if (
            fromPoleSide == fromAddtionalPole &&
            toPoleSide == toAdditionalPole
        ) {
            allPossiblePolePositions.push("#" + (i + 1));
        }
    }
    allPossiblePolePositions.push(toPoleSide);
}

/**
 * generate all possible positions for poles for mouitnig, glass, zip...
 *              INPUTS are all the poles for one side, for example - "'P1', '#3', 'P2'",
 *              OUTPUTS are all combinations of between the poles for that side are-  ('P1-#3', 'P1-P2', '#3-P2', ')
 */
function allPossibleCombinationsForOneSide(selectedSideArray) {
    allPossibleCombinations = [];
    for (let index = 0; index < selectedSideArray.length - 1; index++) {
        let fromPoleSide = selectedSideArray[index].split("-")[0];
        let toPoleSide = selectedSideArray[index + 1].split("-")[0];
        allPossibleCombinations.push(fromPoleSide + "-" + toPoleSide);

        // for (let i = 1; i < selectedSideArray.length; i++) {
        //     let j = i + index;
        //     if (j < selectedSideArray.length) {
        //         let toPoleSide = selectedSideArray[j].split("-")[0];
        //         if (
        //             fromPoleSide.split("")[0] == "P" &&
        //             toPoleSide.split("")[0] == "P" &&
        //             selectedSideArray.length != 2
        //         ) {
        //             break;
        //         }

        //         allPossibleCombinations.push(fromPoleSide + "-" + toPoleSide);
        //     } else break;
        // }
    }
}

/**
 * Reading and submiting WALL MOUNTING from input fields
 * Reading and submiting WALL MOUNTING from input fields
 * Reading and submiting WALL MOUNTING from input fields
 * Reading and submiting WALL MOUNTING from input fields
 * Reading and submiting WALL MOUNTING from input fields *
 */

//read and display value from globalWallMounting
function submitWallMountingHTML() {
    var newHTML = "<div>";
    inputFieldOptGroup(
        "wallMountingSelector",
        onPositionSelect_wallMountingSelector
    );

    // --------------------------------
    for (let index = 0; index < globalInputWallMountingArray.length; index++) {
        newHTML += `
            <div class="my-card mdc-card mdc-card--outlined d-inline-block" style="min-width:300px">
                <div
                    class="mdc-card__content my-card-content"
                    style="padding-left: 10px; padding-right: 10px"
                >
                    <span id = "wall_mounting_${index}" >  
                        ${globalInputWallMountingArray[index].position}
                    </span> 
                    Wall mounting
                    
                    <button
                        class="
                            mdc-icon-button
                            material-icons
                            close-button
                        "
                        id="${index}"
                        onclick="removeValueInGlobalInputWallMountingArray(${index})"
                    >
                        <div class="mdc-icon-button__ripple"></div>
                        close
                    </button>

                    <!-- SWITCH -->
                    <div
                        class="w-100"
                        style="margin-top: 20px"
                    >
                        <button
                            id="wall_mounting_full_height_${index}"
                            class="mdc-switch mdc-switch--unselected ${
                                globalInputWallMountingArray[index].full_height
                                    ? "mdc-switch--selected"
                                    : ""
                            }"
                            type="button"
                            role="switch"
                            aria-checked="${
                                globalInputWallMountingArray[index].full_height
                            }"
                            onclick="changeFullHeightOfWallMounting(${index})"
                        >
                            <div class="mdc-switch__track"></div>
                            <div class="mdc-switch__handle-track">
                                <div class="mdc-switch__handle">
                                    <div class="mdc-switch__shadow">
                                        <div class="mdc-elevation-overlay"></div>
                                    </div>
                                    <div class="mdc-switch__ripple"></div>
                                    <div class="mdc-switch__icons">
                                        <svg
                                            class="
                                                mdc-switch__icon
                                                mdc-switch__icon--on
                                            "
                                            viewBox="0 0 24 24"
                                        >
                                            <path
                                                d="M19.69,5.23L8.96,15.96l-4.23-4.23L2.96,13.5l6,6L21.46,7L19.69,5.23z"
                                            />
                                        </svg>
                                        <svg
                                            class="
                                                mdc-switch__icon
                                                mdc-switch__icon--off
                                            "
                                            viewBox="0 0 24 24"
                                        >
                                            <path d="M20 13H4v-2h16v2z" />
                                        </svg>
                                    </div>
                                </div>
                            </div>
                        </button>
                        <label for="wall_mounting_full_height_${index}">Full height</label>
                    </div>
                </div>
            </div>
        `;
    }

    newHTML += "</div>";

    document.getElementById("wallMountingContainer").innerHTML = newHTML;

    for (let index = 0; index < globalInputWallMountingArray.length; index++) {
        let item_id = `wall_mounting_full_height_${index}`;
        const item = document.getElementById(item_id);

        const MDCSwitch = mdc.switchControl.MDCSwitch;
        const switchControl = new MDCSwitch(item);
    }
}

//change full height of wall
function changeFullHeightOfWallMounting(index) {
    globalInputWallMountingArray[index].full_height =
        !globalInputWallMountingArray[index].full_height;

    globalWallMountingArrayChanges = true;
    updateInputFields();
}

// on select, add new value
function onPositionSelect_wallMountingSelector(value) {
    if (value == undefined) {
        return;
    }

    const exists = globalInputWallMountingArray.find(
        (item) => item.position == value
    );

    if (exists == undefined) {
        // add element to list
        globalInputWallMountingArray.push({
            position: value,
            full_height: true,
        });
    }

    globalWallMountingArrayChanges = true;
    updateInputFields();
}

//remove value from globalInputwallMountingArray
function removeValueInGlobalInputWallMountingArray(index) {
    globalWallMountingArrayChanges = true;
    globalInputWallMountingArray.splice(index, 1);
    updateInputFields();
}

/**
 * Reading and submiting GLASS from input fields
 * Reading and submiting GLASS from input fields
 * Reading and submiting GLASS from input fields
 * Reading and submiting GLASS from input fields
 * Reading and submiting GLASS from input fields *
 */

//read and display value from globalWallMounting
function submitGlassHTML() {
    var newHTML = "<div>";
    inputFieldOptGroup("glassSelector", onPositionSelect_glassSelector);

    for (let index = 0; index < globalInputGlassArray.length; index++) {
        newHTML += `
            <div class="my-card mdc-card mdc-card--outlined d-inline-block">
                <div
                    class="mdc-card__content my-card-content"
                    style="padding-left: 10px; padding-right: 10px"
                >
                    <span id = "glassPosition_${index}" >  
                        ${globalInputGlassArray[index].position}
                    </span> 
                    Sliding panel
                    
                    <button
                        class="
                            mdc-icon-button
                            material-icons
                            close-button
                        "
                        id="${index}"
                        onclick="removeValueInGlobalInputGlassArray(${index})"
                    >
                        <div class="mdc-icon-button__ripple"></div>
                        close
                    </button>

                   

                    <!-- INPUT -->
                    <div 
                        class="
                            mdc-form-field
                            w-100
                        "
                        style="margin-top: 20px"
                    >
                        <div class="mdc-radio">
                            <input 
                                class="mdc-radio__native-control"
                                type="radio" 
                                id="radio-1" 
                                name="slide_type" 
                                ${
                                    globalInputGlassArray[index].type ==
                                    "ONE_GUIDE_STANDARD"
                                        ? "checked"
                                        : ""
                                }
                                onchange = "changeGlassType(${index}, 'ONE_GUIDE_STANDARD')"
                            />
                            <div class="mdc-radio__background">
                            <div class="mdc-radio__outer-circle"></div>
                            <div class="mdc-radio__inner-circle"></div>
                            </div>
                            <div tyle="cursor: pointer" class="mdc-radio__ripple"></div>
                        </div>
                        <label for="radio-1">Standard</label>

                        <div class="mdc-radio">
                            <input 
                                class="mdc-radio__native-control"
                                type="radio" 
                                id="radio-2" 
                                name="slide_type" 
                                ${
                                    globalInputGlassArray[index].type ==
                                    "ONE_GUIDE_REVERSE"
                                        ? "checked"
                                        : ""
                                }
                                onchange = "changeGlassType(${index}, 'ONE_GUIDE_REVERSE')" 
                            />
                            <div class="mdc-radio__background">
                            <div class="mdc-radio__outer-circle"></div>
                            <div class="mdc-radio__inner-circle"></div>
                            </div>
                            <div class="mdc-radio__ripple"></div>
                        </div>
                        <label style="cursor: pointer" for="radio-2">Reverse</label>

                        <div class="mdc-radio">
                            <input 
                                class="mdc-radio__native-control"
                                type="radio" 
                                id="radio-3" 
                                name="slide_type" 
                                ${
                                    globalInputGlassArray[index].type ==
                                    "ONE_GUIDE_FULL"
                                        ? "checked"
                                        : ""
                                }
                                onchange = "changeGlassType(${index}, 'ONE_GUIDE_FULL')" 
                            />
                            <div class="mdc-radio__background">
                            <div class="mdc-radio__outer-circle"></div>
                            <div class="mdc-radio__inner-circle"></div>
                            </div>
                            <div class="mdc-radio__ripple"></div>
                        </div>
                        <label style="cursor: pointer" for="radio-3">Full</label>
                    </div>
                </div>
            </div>
        `;
    }

    newHTML += "</div>";

    document.getElementById("glassContainer").innerHTML = newHTML;
}

//change glass type
function changeGlassType(index, value) {
    globalInputGlassArray[index].type = value;

    globalWallGlassArrayChanges = true;
    updateInputFields();
}

// on select, add new value
function onPositionSelect_glassSelector(value) {
    if (value == undefined) {
        return;
    }

    const exists = globalInputGlassArray.find((item) => item.position == value);

    if (exists == undefined) {
        // add element to list
        globalInputGlassArray.push({
            position: value,
            type: "ONE_GUIDE_STANDARD",
        });
    }

    globalWallGlassArrayChanges = true;
    updateInputFields();
    // const element = document.getElementById("glassSelector_selected_input");

    // let newHtml = "";
    // const placeholder = document.getElementById("glassHolder");
    // // add element to list
    // globalInputGlassArray.push({
    //     position: element.value,
    //     type: "ONE_GUIDE_STANDARD",
    // });
    // placeholder.innerHTML = newHtml;

    // globalWallGlassArrayChanges = true;
    // updateInputFields();
}

//remove value from globalInputGlassArray
function removeValueInGlobalInputGlassArray(index) {
    globalInputGlassArray.splice(index, 1);
    globalWallGlassArrayChanges = true;
    updateInputFields();
}

/**
 * Reading and submiting ZIP from input fields
 * Reading and submiting ZIP from input fields
 * Reading and submiting ZIP from input fields
 * Reading and submiting ZIP from input fields
 * Reading and submiting ZIP from input fields *
 */

//read and display value from globalZip
function submitZipHTML() {
    var newHTML = "<div>";
    inputFieldOptGroup("zipSelector", onPositionSelect_zipSelector);

    /**
     * Keeps ids of div-s for color pickers
     */
    let ids = [];

    for (let index = 0; index < globalInputZipArray.length; index++) {
        newHTML += `
            <div class="my-card mdc-card mdc-card--outlined d-inline-block">
                <div
                    class="mdc-card__content my-card-content"
                    style="padding-left: 10px; padding-right: 10px"
                >
                    <span id = "zipPosition_${index}" >  
                        ${globalInputZipArray[index].position}
                    </span> 
                    ZIP panel
                    
                    <button
                        class="
                            mdc-icon-button
                            material-icons
                            close-button
                        "
                        id="${index}"
                        onclick="removeValueInGlobalInputZipArray(${index})"
                    >
                        <div class="mdc-icon-button__ripple"></div>
                        close
                    </button>

                    <!-- INPUT -->
                    <div id="zip_color_${index}"></div>
                </div>
            </div>
        `;

        // save id since we need to override div for color picker
        ids.push(`zip_color_${index}`);
    }

    newHTML += "</div>";

    document.getElementById("zipContainer").innerHTML = newHTML;

    // prepare color picker for every zip

    for (let i = 0; i < ids.length; i++) {
        const id = ids[i];
        const { newHtml, builder } = createColorPickerMenu(
            globalInputZipArray[i].color,
            false
        );

        document.getElementById(id).innerHTML = newHtml;

        builder(id, function (value) {
            return changeZipColor(i, value);
        });
    }
}

//change zip color
function changeZipColor(index, value) {
    globalInputZipArray[index].color = value;

    globalZipArrayChanges = true;
    updateInputFields();
}

// on select, add new value
function onPositionSelect_zipSelector(value) {
    if (value == undefined) {
        return;
    }

    const exists = globalInputZipArray.find((item) => item.position == value);

    if (exists == undefined) {
        // add element to list
        globalInputZipArray.push({
            position: value,
            color: "RAL_9011",
        });
    }

    globalZipArrayChanges = true;
    updateInputFields();
}

//remove value from globalInputZipArray
function removeValueInGlobalInputZipArray(index) {
    globalInputZipArray.splice(index, 1);
    globalZipArrayChanges = true;
    updateInputFields();
}

/**
 * Reading and submiting SLIDING from input fields
 * Reading and submiting SLIDING from input fields
 * Reading and submiting SLIDING from input fields
 * Reading and submiting SLIDING from input fields
 * Reading and submiting SLIDING from input fields *
 */

//read and display value from global SLIDING
function submitSlidingHTML() {
    var newHTML = "<div>";

    inputFieldOptGroup("slideSelector", onPositionSelect_slideSelector);

    for (let index = 0; index < globalInputSlideArray.length; index++) {
        newHTML += `
            <div class="my-card mdc-card mdc-card--outlined d-inline-block">
                <div
                    class="mdc-card__content my-card-content"
                    style="padding-left: 10px; padding-right: 10px"
                >
                    <span id = "slidePosition_${index}" >  
                        ${globalInputSlideArray[index].position}
                    </span> 
                    Sliding panel
                    
                    <button
                        class="
                            mdc-icon-button
                            material-icons
                            close-button
                        "
                        id="${index}"
                        onclick="removeValueInGlobalInputSlideArray(${index})"
                    >
                        <div class="mdc-icon-button__ripple"></div>
                        close
                    </button>

                    <!-- INPUT -->
                    <label
                        class="
                            mdc-text-field mdc-text-field--outlined
                            w-100
                        "
                        style="margin-top: 20px"
                    >
                        <span class="mdc-notched-outline">
                            <span
                                class="mdc-notched-outline__leading"
                            ></span>
                            <span
                                class="mdc-notched-outline__notch"
                            >
                                <span
                                    class="mdc-floating-label"
                                    id="my-label-id"
                                >
                                    Width (mm)
                                </span>
                            </span>
                            <span
                                class="
                                    mdc-notched-outline__trailing
                                "
                            ></span>
                        </span>
                        <input
                            type="number"
                            class="mdc-text-field__input"
                            aria-labelledby="my-label-id"
                            id = "slide_width_${index}" 
                            name = "slide_width_${index}" 
                            value = "${globalInputSlideArray[index].width}"
                            onchange = "changeSlideWidth(${index})" 
                        />

                    </label>

                    <!-- INPUT -->
                    <label
                        class="
                            mdc-text-field mdc-text-field--outlined
                            w-100
                        "
                        style="margin-top: 20px"
                    >
                        <span class="mdc-notched-outline">
                            <span
                                class="mdc-notched-outline__leading"
                            ></span>
                            <span
                                class="mdc-notched-outline__notch"
                            >
                                <span
                                    class="mdc-floating-label"
                                    id="my-label-id"
                                >
                                    Number of slides
                                </span>
                            </span>
                            <span
                                class="
                                    mdc-notched-outline__trailing
                                "
                            ></span>
                        </span>
                        <input
                            type="number"
                            class="mdc-text-field__input"
                            aria-labelledby="my-label-id"
                            id = "number_of_slides${index}" 
                            name = "number_of_slides${index}" 
                            value = "${
                                globalInputSlideArray[index].number_of_panels
                            }"
                            onchange = "changeSlideNumberOfPanels(${index})" 
                        />
                    </label>

                    <!-- INPUT -->
                    <div class="mdc-form-field">
                        <div class="mdc-radio">
                            <input 
                                class="mdc-radio__native-control"
                                type="radio" 
                                id="radio-1" 
                                name="slide_panel_type" 
                                ${
                                    globalInputSlideArray[index].panel_type ==
                                    "WOOD"
                                        ? "checked"
                                        : ""
                                }
                                onchange = "changeSlidePanelType(${index}, 'WOOD')"
                            />
                            <div class="mdc-radio__background">
                            <div class="mdc-radio__outer-circle"></div>
                            <div class="mdc-radio__inner-circle"></div>
                            </div>
                            <div tyle="cursor: pointer" class="mdc-radio__ripple"></div>
                        </div>
                        <label for="radio-1">Wood</label>
                        <div class="mdc-radio">
                            <input 
                                class="mdc-radio__native-control"
                                type="radio" 
                                id="radio-2" 
                                name="slide_panel_type" 
                                ${
                                    globalInputSlideArray[index].panel_type ==
                                    "ALU"
                                        ? "checked"
                                        : ""
                                }
                                onchange = "changeSlidePanelType(${index}, 'ALU')" 
                            />
                            <div class="mdc-radio__background">
                            <div class="mdc-radio__outer-circle"></div>
                            <div class="mdc-radio__inner-circle"></div>
                            </div>
                            <div class="mdc-radio__ripple"></div>
                        </div>
                        <label style="cursor: pointer" for="radio-2">Aluminium</label>
                    </div>
                </div>
            </div>
        `;
    }

    newHTML += "</div>";

    document.getElementById("slideContainer").innerHTML = newHTML;
}

//change slide width
function changeSlideWidth(index) {
    // document.getElementById("changeSlideColor_" + index).value;
    globalInputSlideArray[index].width = parseInt(
        document.getElementById("slide_width_" + index).value
    );
    globalSlideArrayChanges = true;
    updateInputFields();
}

//change panel type DOESNT WORK -> NO NEED FOR IT
function changeSlidePanelType(index, value) {
    // document.getElementById("changeSlideColor_" + index).value;
    globalInputSlideArray[index].panel_type = value;

    globalSlideArrayChanges = true;
    updateInputFields();
}

//change number of panel
function changeSlideNumberOfPanels(index) {
    // document.getElementById("changeSlideColor_" + index).value;
    globalInputSlideArray[index].number_of_panels = parseInt(
        document.getElementById("number_of_slides" + index).value
    );

    globalSlideArrayChanges = true;
    updateInputFields();
}

// on select, add new value
function onPositionSelect_slideSelector(value) {
    if (value == undefined) {
        return;
    }

    const exists = globalInputSlideArray.find((item) => item.position == value);

    if (exists == undefined) {
        // add element to list
        globalInputSlideArray.push({
            position: value,
            width: 750,
            panel_type: "WOOD",
            number_of_panels: 2,
        });
    }

    globalSlideArrayChanges = true;
    updateInputFields();
}

//remove value from globalInputSlideArray
function removeValueInGlobalInputSlideArray(index) {
    globalInputSlideArray.splice(index, 1);
    globalSlideArrayChanges = true;
    updateInputFields();
}

/**
 * Reading and submiting water evacuation from input fields
 * Reading and submiting water evacuation from input fields
 * Reading and submiting water evacuation from input fields
 * Reading and submiting water evacuation from input fields
 * Reading and submiting water evacuation from input fields *
 */

function submitWaterEvacuationHTML() {
    setCheckboxInputs("waterEvacuation", changeWaterEvacuation);
}

function setCheckboxInputs(id) {
    let newHtml = `
        <div class="mdc-form-field">
    `;

    for (let index = 0; index < globalInputWaterEvacuation.length; index++) {
        newHtml += `
            <div>
                <div class="mdc-checkbox">
                    <input
                        type="checkbox"
                        class="mdc-checkbox__native-control"
                        id="checkbox-${id}-${
            globalInputWaterEvacuation[index].key
        }"
                        value=true
                        ${
                            globalInputWaterEvacuation[index].checked
                                ? "checked"
                                : ""
                        }
                        onchange="changeWaterEvacuation(${index}, '${id}', '${
            globalInputWaterEvacuation[index].key
        }')"
                    />
                    <div class="mdc-checkbox__background">
                        <svg
                            class="mdc-checkbox__checkmark"
                            viewBox="0 0 24 24"
                        >
                            <path
                                class="mdc-checkbox__checkmark-path"
                                fill="none"
                                d="M1.73,12.91 8.1,19.28 22.79,4.59"
                            />
                        </svg>
                        <div class="mdc-checkbox__mixedmark"></div>
                    </div>
                    <div class="mdc-checkbox__ripple"></div>
                </div>
                <label style="cursor: pointer" for="checkbox-${id}-${
            globalInputWaterEvacuation[index].key
        }">
                    ${globalInputWaterEvacuation[index].position}
                </label>

            </div>
        `;
    }

    newHtml += `
        </div>
    `;

    // set new body
    document.getElementById(id + "Selector").innerHTML = newHtml;
}

//change slide width
function changeWaterEvacuation(index, id, key) {
    // document.getElementById("changeSlideColor_" + index).value;
    globalInputWaterEvacuation[index].checked = document.getElementById(
        "checkbox-" + id + "-" + key
    ).checked;

    globalWaterEvacuationChanges = true;
    updateInputFields();
}

// on select, add new value
function onPositionSelect_waterEvacuation(value) {
    if (value == undefined) {
        return;
    }

    // add element to list
    globalInputWaterEvacuation.push({
        position: "(W) A" + value.split("")[1],
    });

    globalWaterEvacuationChanges = true;
    updateInputFields();
}

//remove value from globalInputSlideArray
function removeValueInGlobalInputWaterEvacuation(index) {
    globalInputWaterEvacuation.splice(index, 1);
    globalWaterEvacuationChanges = true;
    updateInputFields();
}

/**
 * Reading and submiting power supply from input fields
 * Reading and submiting power supply from input fields
 * Reading and submiting power supply from input fields
 * Reading and submiting power supply from input fields
 * Reading and submiting power supply from input fields *
 */

function submitPowerSupplyHTML() {
    let newHtml = "";

    newHtml += `
        <div class="w-100 mdc-select mdc-select--outlined">
            <div
                class="mdc-select__anchor"
                aria-labelledby="outlined-select-label"
            >
                <span class="mdc-notched-outline">
                    <span
                        class="mdc-notched-outline__leading"
                    ></span>
                    <span class="mdc-notched-outline__notch">
                        <span
                            id="outlined-select-label"
                            class="mdc-floating-label"
                        >
                            Select Power supply
                        </span>
                    </span>
                    <span
                        class="mdc-notched-outline__trailing"
                    ></span>
                </span>
                <span
                    class="mdc-select__selected-text-container"
                >
                    <span
                        id="demo-selected-text"
                        class="mdc-select__selected-text"
                    >${globalInputPowerSupply}</span>
                </span>
                <span class="mdc-select__dropdown-icon">
                    <svg
                        class="
                            mdc-select__dropdown-icon-graphic
                        "
                        viewBox="7 10 10 5"
                        focusable="false"
                    >
                        <polygon
                            class="
                                mdc-select__dropdown-icon-inactive
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 10 12 15 17 10"
                        ></polygon>
                        <polygon
                            class="
                                mdc-select__dropdown-icon-active
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 15 12 10 17 15"
                        ></polygon>
                    </svg>
                </span>
            </div>

            <div
                class="
                    mdc-select__menu
                    mdc-menu
                    mdc-menu-surface
                    mdc-menu-surface--fullwidth
                "
            >
                <ul
                    class="mdc-list"
                    role="listbox"
                    aria-label="Power supply position"
                >
                    
    `;
    const options = ["/", "(P) P1", "(P) P2", "(P) P3", "(P) P4"];
    for (const option of options) {
        newHtml += `
                        <li
                            class="mdc-list-item ${
                                globalInputPowerSupply == option
                                    ? "mdc-list-item--selected"
                                    : ""
                            }" 
                            ${
                                globalInputPowerSupply == option
                                    ? 'aria-selected="true"'
                                    : ""
                            }
                            data-value="${option}"
                            role="option"
                        >
                            <span
                                class="mdc-list-item__ripple"
                            ></span>
                            <span class="mdc-list-item__text">
                                ${option}
                            </span>
                        </li>
        `;
    }

    newHtml += `
                </ul>
            </div>
        </div>
    `;

    // set new body
    document.getElementById("powerSupplyContainer").innerHTML = newHtml;

    // set listener for material select changes
    const item = document.getElementById("powerSupplyContainer");

    const MDCSelect = mdc.select.MDCSelect;
    const selectControl = new MDCSelect(item);

    // do not add one more listener for same field if it already exists
    if (listeners["powerSupplyContainer"] == undefined) {
        listeners["powerSupplyContainer"] = true;

        // listen for any changes and call on input change function with
        // new value
        selectControl.listen("MDCSelect:change", (event) => {
            changePowerSupply(event.detail.value);
        });
    }
}

//change Power Supply
function changePowerSupply(value) {
    // document.getElementById("changeSlideColor_" + index).value;
    globalInputPowerSupply = value;
    globalPowerSupplyChanges = true;
    updateInputFields();
}

/**
 * Reading and submiting motor from input fields
 * Reading and submiting motor from input fields
 * Reading and submiting motor from input fields
 * Reading and submiting motor from input fields
 * Reading and submiting motor from input fields *
 */

function submitMotorHTML() {
    let newHtml = "";

    newHtml += `
        <div class="w-100 mdc-select mdc-select--outlined">
            <div
                class="mdc-select__anchor"
                aria-labelledby="outlined-select-label"
            >
                <span class="mdc-notched-outline">
                    <span
                        class="mdc-notched-outline__leading"
                    ></span>
                    <span class="mdc-notched-outline__notch">
                        <span
                            id="outlined-select-label"
                            class="mdc-floating-label"
                        >
                            Select Motor Position
                        </span>
                    </span>
                    <span
                        class="mdc-notched-outline__trailing"
                    ></span>
                </span>
                <span
                    class="mdc-select__selected-text-container"
                >
                    <span
                        id="demo-selected-text"
                        class="mdc-select__selected-text"
                    >${globalInputMotor}</span>
                </span>
                <span class="mdc-select__dropdown-icon">
                    <svg
                        class="
                            mdc-select__dropdown-icon-graphic
                        "
                        viewBox="7 10 10 5"
                        focusable="false"
                    >
                        <polygon
                            class="
                                mdc-select__dropdown-icon-inactive
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 10 12 15 17 10"
                        ></polygon>
                        <polygon
                            class="
                                mdc-select__dropdown-icon-active
                            "
                            stroke="none"
                            fill-rule="evenodd"
                            points="7 15 12 10 17 15"
                        ></polygon>
                    </svg>
                </span>
            </div>

            <div
                class="
                    mdc-select__menu
                    mdc-menu
                    mdc-menu-surface
                    mdc-menu-surface--fullwidth
                "
            >
                <ul
                    class="mdc-list"
                    role="listbox"
                    aria-label="Motor position"
                >
                    
    `;
    const options = ["/", "(M) A", "(M) B"];
    for (const option of options) {
        newHtml += `
                        <li
                            class="mdc-list-item ${
                                globalInputMotor == option
                                    ? "mdc-list-item--selected"
                                    : ""
                            }" 
                            ${
                                globalInputMotor == option
                                    ? 'aria-selected="true"'
                                    : ""
                            }
                            data-value="${option}"
                            role="option"
                        >
                            <span
                                class="mdc-list-item__ripple"
                            ></span>
                            <span class="mdc-list-item__text">
                                ${option}
                            </span>
                        </li>
        `;
    }

    newHtml += `
                </ul>
            </div>
        </div>
    `;

    // set new body
    document.getElementById("motorPositionContainer").innerHTML = newHtml;

    // set listener for material select changes
    const item = document.getElementById("motorPositionContainer");

    const MDCSelect = mdc.select.MDCSelect;
    const selectControl = new MDCSelect(item);

    // do not add one more listener for same field if it already exists
    if (listeners["motorPositionContainer"] == undefined) {
        listeners["motorPositionContainer"] = true;

        // listen for any changes and call on input change function with
        // new value
        selectControl.listen("MDCSelect:change", (event) => {
            changeMotorPosition(event.detail.value);
        });
    }
}

//change motor
function changeMotorPosition(value) {
    globalInputMotor = value;
    globaltMotorChanges = true;
    updateInputFields();
}

// // backup group
// function backupGroup() {
//     var meshes = window.appGlobal.scene.children;
//     console.log(meshes[1].type);

//     const elements = [];

//     for (let index = 0; index < meshes.length; index++) {
//         if (meshes[index].type == "Mesh" || meshes[index].type == "Group") {
//             elements.push(meshes[index].name);
//         }
//     }
//     console.log("meshes ARRAY", elements);

//     const group = new THREE.Group();
//     for (const name of elements) {
//         const obj = window.appGlobal.scene.getObjectByName(name);
//         if (obj) {
//             group.add(obj);
//         }
//     }
//     console.log(group);
//     // group.position.x = 3;
//     // group.scale.set(
//     //     group.scale.x * 0.9,
//     //     group.scale.y * 0.9,
//     //     group.scale.z * 0.9
//     // );
//     group.rotation.y += 0.2;

//     window.appGlobal.scene.add(group);

//     // v3d.puzzles.procedures.pActivateAR();
// }

//activate AR
function activateAR() {
    v3d.puzzles.procedures.hidePlaneAndMesures();

    v3d.puzzles.procedures.pActivateAR();
}

// // function grouping all meshes into one. Otherwords makes union of all blender objects
// function groupAllMeshes() {
//     var meshes = window.appGlobal.scene.children;
//     console.log(meshes[1].type);

//     const elements = [];

//     for (let index = 0; index < meshes.length; index++) {
//         if (meshes[index].type == "Mesh" || meshes[index].type == "Group") {
//             elements.push(meshes[index].name);
//         }
//     }
//     console.log("meshes ARRAY", elements);

//     const group = new THREE.Group();
//     for (const name of elements) {
//         const obj = window.appGlobal.scene.getObjectByName(name);
//         if (obj) {
//             group.add(obj);
//         }
//     }
//     console.log(group);
//     // group.position.x = 3;
//     // group.scale.set(
//     //     group.scale.x * 0.9,
//     //     group.scale.y * 0.9,
//     //     group.scale.z * 0.9
//     // );
//     group.rotation.y += 0.2;

//     window.appGlobal.scene.add(group);
// }
